/*	$Id: audio.h,v 1.2 2003/06/05 18:10:16 nonaka Exp $	*/

/*
 * Copyright (c) 2001-2003 NONAKA Kimihiro
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef	__NP2_AUDIO_H__
#define	__NP2_AUDIO_H__

#include "np2.h"
#include "np2os.h"
#include "np2pc98.h"

enum {
	SNDDRV_NODRV,
	SNDDRV_NETBSD,
	SNDDRV_OSS,
	SNDDRV_ESD,
	SNDDRV_SDL,
	SNDDRV_DRVMAX
};

#define	NSOUNDBUFFER	2

typedef struct np2_audiodriver {
	BOOL (*init)(DWORD, DWORD);
	BOOL (*term)(void);
	void (*play)(void);
	void (*stop)(void);
} audiodrv_t;

extern int audio_fd;
extern audiodrv_t audiodrv;

extern char audiodev[MAX_PATH];

extern int audio_nextbuf;
extern char *audio_event;
extern char *audio_buffer[NSOUNDBUFFER];

void audio_setup(void);

BYTE audio_drv2num(char *);
char* audio_num2drv(BYTE);

DWORD calc_blocksize(DWORD size);
int calc_fragment(DWORD size);

void audio_generic_play(void);
void audio_generic_stop(void);

int netbsdaudio_setup(void);
int ossaudio_setup(void);
int esdaudio_setup(void);
int sdlaudio_setup(void);

#endif	/* __NP2_AUDIO_H__ */
