%define	I286_MEMREADMAX		0a4000h
%define	I286_MEMWRITEMAX	0a0000h

struc	I286REG_BYTE
	.al		resb	1
	.ah		resb	1
	.cl		resb	1
	.ch		resb	1
	.dl		resb	1
	.dh		resb	1
	.bl		resb	1
	.bh		resb	1
	.sp_l		resb	1
	.sp_h		resb	1
	.bp_l		resb	1
	.bp_h		resb	1
	.si_l		resb	1
	.si_h		resb	1
	.di_l		resb	1
	.di_h		resb	1
	.es_l		resb	1
	.es_h		resb	1
	.cs_l		resb	1
	.cs_h		resb	1
	.ss_l		resb	1
	.ss_h		resb	1
	.ds_l		resb	1
	.ds_h		resb	1
	.flag_l		resb	1
	.flag_h		resb	1
	.ip_l		resb	1
	.ip_h		resb	1
endstruc

struc	I286REG_WORD
	.ax		resw	1
	.cx		resw	1
	.dx		resw	1
	.bx		resw	1
	.sp		resw	1
	.bp		resw	1
	.si		resw	1
	.di		resw	1
	.es		resw	1
	.cs		resw	1
	.ss		resw	1
	.ds		resw	1
	.flag		resw	1
	.ip		resw	1
endstruc

struc	I286STAT
	.es_base	resd	1
	.cs_base	resd	1
	.ss_base	resd	1
	.ds_base	resd	1
	.ss_fix		resd	1
	.ds_fix		resd	1
	.prefix		resd	1
	.trap		resd	1
	.ovflag		resd	1
	.pf_semaphore	resd	1
	.repbak		resd	1
	.inport		resd	1
	.cpu_type	resb	1
endstruc

struc	DTR_TABLE
	.limit		resw	1
	.base		resw	1
	.base24		resb	1
	.reserved	resb	1
endstruc

extern	i286r
extern	i286s
extern	szpcflag
extern	iflags
extern	GDTR
extern	IDTR
extern	MSW


%define	I286_MEM	mem

%define	I286_REG	i286r
%define	I286_SEGREG	(i286r + I286REG_WORD.es)

%define	I286_AX		(i286r + I286REG_WORD.ax)
%define	I286_BX		(i286r + I286REG_WORD.bx)
%define	I286_CX		(i286r + I286REG_WORD.cx)
%define	I286_DX		(i286r + I286REG_WORD.dx)
%define	I286_SI		(i286r + I286REG_WORD.si)
%define	I286_DI		(i286r + I286REG_WORD.di)
%define	I286_BP		(i286r + I286REG_WORD.bp)
%define	I286_SP		(i286r + I286REG_WORD.sp)
%define	I286_CS		(i286r + I286REG_WORD.cs)
%define	I286_DS		(i286r + I286REG_WORD.ds)
%define	I286_ES		(i286r + I286REG_WORD.es)
%define	I286_SS		(i286r + I286REG_WORD.ss)
%define	I286_IP		(i286r + I286REG_WORD.ip)

%define	SEG_BASE	(i286s + I286STAT.es_base)
%define	ES_BASE		(i286s + I286STAT.es_base)
%define	CS_BASE		(i286s + I286STAT.cs_base)
%define	SS_BASE		(i286s + I286STAT.ss_base)
%define	DS_BASE		(i286s + I286STAT.ds_base)
%define	SS_FIX		(i286s + I286STAT.ss_fix)
%define	DS_FIX		(i286s + I286STAT.ds_fix)

%define	I286_AL		(i286r + I286REG_BYTE.al)
%define	I286_BL		(i286r + I286REG_BYTE.bl)
%define	I286_CL		(i286r + I286REG_BYTE.cl)
%define	I286_DL		(i286r + I286REG_BYTE.dl)
%define	I286_AH		(i286r + I286REG_BYTE.ah)
%define	I286_BH		(i286r + I286REG_BYTE.bh)
%define	I286_CH		(i286r + I286REG_BYTE.ch)
%define	I286_DH		(i286r + I286REG_BYTE.dh)

%define	I286_FLAG	(i286r + I286REG_WORD.flag)
%define	I286_FLAGL	(i286r + I286REG_BYTE.flag_l)
%define	I286_FLAGH	(i286r + I286REG_BYTE.flag_h)
%define	I286_TRAP	(i286s + I286STAT.trap)
%define	I286_OV		(i286s + I286STAT.ovflag)

%define	C_FLAG		0001h
%define	P_FLAG		0004h
%define	A_FLAG		0010h
%define	Z_FLAG		0040h
%define	S_FLAG		0080h
%define	T_FLAG		0100h
%define	I_FLAG		0200h
%define	D_FLAG		0400h
%define	O_FLAG		0800h

%define	CPUTYPE		(i286s + I286STAT.cpu_type)
%define	CPUTYPE_V30	1

; ver0.28
%define	REPPOSBAK	(i286s + I286STAT.repbak)
%define	PREFIX_SMP	(i286s + I286STAT.pf_semaphore)
