;	$Id: i286a_rp.asm,v 1.3 2002/11/05 15:13:32 nonaka Exp $

%include "np2asm.inc"
%include "cpu.inc"
%include "cpu.mcr"


%macro	LOAD_DS_SI	0
	mov	edi, dword [DS_FIX]
	movzx	ebx, word [I286_SI]
%endmacro


; ---------------------------------------------------------------------- ins
global rep_insb
	align	16
rep_insb:
	I286CLOCK 5 
	cmp	word [I286_CX], 0
	je	.insb_ed
	mov	edi, ES_BASE
	movzx	ebx, word [I286_DI]

.insb_lp:
	I286CLOCK 4
	mov	cx, word [I286_DX]
	call	@i286_in@4
	lea	ecx, [edi + ebx]
	mov	dl, al
	call	@i286_memorywrite@8
	STRING_DIR
	add	bx, ax
	dec	word [I286_CX]
	jne	.insb_lp

	mov	word [I286_DI], bx
.insb_ed:
	ret

global rep_insw
	align	16
rep_insw:
	I286CLOCK 5
	cmp	word [I286_CX], 0
	je	.insw_ed

	mov	edi, dword [ES_BASE]
	movzx	ebx, word [I286_DI]
.insw_lp:
	I286CLOCK 4
	mov	cx, word [I286_DX]
	call	@i286_in_w@4
	lea	ecx, [edi + ebx]
	mov	dx, ax
	call	@i286_memorywrite_w@8
	STRING_DIRx2
	add	bx, ax
	dec	word [I286_CX]
	jne	.insw_lp

	mov	word [I286_DI], bx
.insw_ed:
	ret

; ---------------------------------------------------------------------- outs
global rep_outsb
	align	16
rep_outsb:
	I286CLOCK 5
	cmp	word [I286_CX], 0
	je	.outsb_ed

	LOAD_DS_SI
.outsb_lp:
	I286CLOCK 4
	lea	ecx, [edi + ebx]
	call	@i286_memoryread@4
	mov	cx, word [I286_DX]
	mov	dl, al
	call	@i286_out@8
	STRING_DIR
	add	bx, ax
	dec	word [I286_CX]
	jne	.outsb_lp

	mov	word [I286_SI], bx
.outsb_ed:
	ret

global rep_outsw
	align	16
rep_outsw:
	I286CLOCK 5
	cmp	word [I286_CX], 0
	je	.outsw_ed

	LOAD_DS_SI
.outsw_lp:
	I286CLOCK 4
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	cx, word [I286_DX]
	mov	dx, ax
	call	@i286_out_w@8
	STRING_DIRx2
	add	bx, ax
	dec	word [I286_CX]
	jne	.outsw_lp

	mov	word [I286_SI], bx
.outsw_ed:
	ret

; ---------------------------------------------------------------------- movs
global rep_movsb
	align	16
rep_movsb:
	I286CLOCK 5
	cmp	word [I286_CX], 0
	je	.movsb_ed

	push	esi
	push	ebp
	LOAD_DS_SI
	mov	esi, dword [ES_BASE]
	movzx	ebp, word [I286_DI]
.movsb_lp:
	I286CLOCK 4
	lea	ecx, [edi + ebx]
	call	@i286_memoryread@4
	mov	edx, eax
	lea	ecx, [esi + ebp]
	call	@i286_memorywrite@8
	STRING_DIR
	add	bx, ax
	add	bp, ax
	dec	word [I286_CX]
	jne	.movsb_lp

	mov	word [I286_SI], bx
	mov	word [I286_DI], bp
	pop	ebp
	pop	esi
.movsb_ed:
	ret

global rep_movsw
	align	16
rep_movsw:
	I286CLOCK 5
	cmp	word [I286_CX], 0
	je	.movsw_ed

	push	esi
	push	ebp
	LOAD_DS_SI
	mov	esi, dword [ES_BASE]
	movzx	ebp, word [I286_DI]
.movsw_lp:
	I286CLOCK 4
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	edx, eax
	lea	ecx, [esi + ebp]
	call	@i286_memorywrite_w@8
	STRING_DIRx2
	add	bx, ax
	add	bp, ax
	dec	word [I286_CX]
	jne	.movsw_lp

	mov	word [I286_SI], bx
	mov	word [I286_DI], bp
	pop	ebp
	pop	esi
.movsw_ed:
	ret

; ---------------------------------------------------------------------- lods
global rep_lodsb
	align	16
rep_lodsb:
	I286CLOCK 5
	cmp	word [I286_CX], 0
	je	.lodsb_ed

	LOAD_DS_SI
.lodsb_lp:
	I286CLOCK 4
	lea	ecx, [edi + ebx]
	call	@i286_memoryread@4
	mov	[I286_AL], al
	STRING_DIR
	add	bx, ax
	dec	word [I286_CX]
	jne	.lodsb_lp

	mov	word [I286_SI], bx
.lodsb_ed:
	ret

global rep_lodsw
	align	16
rep_lodsw:
	I286CLOCK 5
	cmp	word [I286_CX], 0
	je	.lodsw_ed

	LOAD_DS_SI
.lodsw_lp:
	I286CLOCK 4
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	word [I286_AX], ax
	STRING_DIRx2
	add	bx, ax
	dec	word [I286_CX]
	jne	.lodsw_lp

	mov	word [I286_SI], bx
.lodsw_ed:
	ret

; ---------------------------------------------------------------------- stos
global rep_stosb
	align	16
rep_stosb:
	I286CLOCK 4
	cmp	word [I286_CX], 0
	je	.stosb_ed

	mov	edi, dword [ES_BASE]
	movzx	ebx, word [I286_DI]
.stosb_lp:
	I286CLOCK 3
	lea	ecx, [edi + ebx]
	mov	dl, [I286_AL]
	call	@i286_memorywrite@8
	STRING_DIR
	add	bx, ax
	dec	word [I286_CX]
	jne	.stosb_lp

	mov	word [I286_DI], bx
.stosb_ed:
	ret

global rep_stosw
	align	16
rep_stosw:
	I286CLOCK 4
	cmp	word [I286_CX], 0
	je	.stosw_ed

	mov	edi, dword [ES_BASE]
	movzx	ebx, word [I286_DI]
.stosw_lp:
	I286CLOCK 3
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_AX]
	call	@i286_memorywrite_w@8
	STRING_DIRx2
	add	bx, ax
	dec	word [I286_CX]
	jne	.stosw_lp

	mov	word [I286_DI], bx
.stosw_ed:
	ret

; ---------------------------------------------------------------------- cmps
global repe_cmpsb
	align	16
repe_cmpsb:
	I286CLOCK 5
	cmp	word [I286_CX], 0
	je	near .cmpsb_ed

	push	esi
	push	ebp
	LOAD_DS_SI
	mov	esi, dword [ES_BASE]
	movzx	ebp, word [I286_DI]
.zcmpsb_lp:
	I286CLOCK 9
	lea	ecx, [edi + ebx]
	call	@i286_memoryread@4
	mov	dl, al
	lea	ecx, [esi + ebp]
	call	@i286_memoryread@4
	cmp	dl, al
	FLAG_STORE_OF
	STRING_DIR
	add	bx, ax
	add	bp, ax
	dec	word [I286_CX]
	je	.zcmpsb_ed
	test	word [I286_FLAG], Z_FLAG
	jne	.zcmpsb_lp

.zcmpsb_ed:
	mov	word [I286_SI], bx
	mov	word [I286_DI], bp
	pop	ebp
	pop	esi
.cmpsb_ed:
	ret

global repne_cmpsb
	align	16
repne_cmpsb:
	I286CLOCK 5
	cmp	word [I286_CX], 0
	je	near .cmpsb_ed

	push	esi
	push	ebp
	LOAD_DS_SI
	mov	esi, dword [ES_BASE]
	movzx	ebp, word [I286_DI]
.nzcmpsb_lp:
	I286CLOCK 9
	lea	ecx, [edi + ebx]
	call	@i286_memoryread@4
	mov	dl, al
	lea	ecx, [esi + ebp]
	call	@i286_memoryread@4
	cmp	dl, al
	FLAG_STORE_OF
	STRING_DIR
	add	bx, ax
	add	bp, ax
	dec	word [I286_CX]
	je	.nzcmpsb_ed
	test	word [I286_FLAG], Z_FLAG
	je	.nzcmpsb_lp

.nzcmpsb_ed:
	mov	word [I286_SI], bx
	mov	word [I286_DI], bp
	pop	ebp
	pop	esi
.cmpsb_ed:
	ret

global repe_cmpsw
	align	16
repe_cmpsw:
	I286CLOCK 5
	cmp	word [I286_CX], 0
	je	near .cmpsw_ed

	push	esi
	push	ebp
	LOAD_DS_SI
	mov	esi, dword [ES_BASE]
	movzx	ebp, word [I286_DI]
.zcmpsw_lp:
	I286CLOCK 9
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	dx, ax
	lea	ecx, [esi + ebp]
	call	@i286_memoryread_w@4
	cmp	dx, ax
	FLAG_STORE_OF
	STRING_DIRx2
	add	bx, ax
	add	bp, ax
	dec	word [I286_CX]
	je	.zcmpsw_ed
	test	word [I286_FLAG], Z_FLAG
	jne	.zcmpsw_lp

.zcmpsw_ed:
	mov	word [I286_SI], bx
	mov	word [I286_DI], bp
	pop	ebp
	pop	esi
.cmpsw_ed:
	ret

global repne_cmpsw
	align	16
repne_cmpsw:
	I286CLOCK 5
	cmp	word [I286_CX], 0
	je	near .cmpsw_ed

	push	esi
	push	ebp
	LOAD_DS_SI
	mov	esi, dword [ES_BASE]
	movzx	ebp, word [I286_DI]
.nzcmpsw_lp:
	I286CLOCK 9
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	mov	dx, ax
	lea	ecx, [esi + ebp]
	call	@i286_memoryread_w@4
	cmp	dx, ax
	FLAG_STORE_OF
	STRING_DIRx2
	add	bx, ax
	add	bp, ax
	dec	word [I286_CX]
	je	.nzcmpsw_ed
	test	word [I286_FLAG], Z_FLAG
	je	.nzcmpsw_lp

.nzcmpsw_ed:
	mov	word [I286_SI], bx
	mov	word [I286_DI], bp
	pop	ebp
	pop	esi
.cmpsw_ed:
	ret

; ---------------------------------------------------------------------- scas
global repe_scasb
	align	16
repe_scasb:
	I286CLOCK 5
	cmp	word [I286_CX], 0
	je	.scasb_ed

	mov	edi, dword [ES_BASE]
	movzx	ebx, word [I286_DI]
.zscasb_lp:
	I286CLOCK 8
	lea	ecx, [edi + ebx]
	call	@i286_memoryread@4
	cmp	[I286_AL], al
	FLAG_STORE_OF
	STRING_DIR
	add	bx, ax
	dec	word [I286_CX]
	je	.zscasb_ed
	test	word [I286_FLAG], Z_FLAG
	jne	.zscasb_lp

.zscasb_ed:
	mov	word [I286_DI], bx
.scasb_ed:
	ret

global repne_scasb
	align	16
repne_scasb:
	I286CLOCK 5
	cmp	word [I286_CX], 0
	je	.scasb_ed

	mov	edi, dword [ES_BASE]
	movzx	ebx, word [I286_DI]
.nzscasb_lp:
	I286CLOCK 8
	lea	ecx, [edi + ebx]
	call	@i286_memoryread@4
	cmp	[I286_AL], al
	FLAG_STORE_OF
	STRING_DIR
	add	bx, ax
	dec	word [I286_CX]
	je	.nzscasb_ed
	test	word [I286_FLAG], Z_FLAG
	je	.nzscasb_lp

.nzscasb_ed:
	mov	word [I286_DI], bx
.scasb_ed:
	ret

global repe_scasw
	align	16
repe_scasw:
	I286CLOCK 5
	cmp	word [I286_CX], 0
	je	.scasw_ed

	mov	edi, dword [ES_BASE]
	movzx	ebx, word [I286_DI]
.zscasw_lp:
	I286CLOCK 8
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	cmp	word [I286_AX], ax
	FLAG_STORE_OF
	STRING_DIRx2
	add	bx, ax
	dec	word [I286_CX]
	je	.zscasw_ed
	test	word [I286_FLAG], Z_FLAG
	jne	.zscasw_lp

.zscasw_ed:
	mov	word [I286_DI], bx
.scasw_ed:
	ret

global repne_scasw
	align	16
repne_scasw:
	I286CLOCK 5
	cmp	word [I286_CX], 0
	je	.scasw_ed

	mov	edi, dword [ES_BASE]
	movzx	ebx, word [I286_DI]
.nzscasw_lp:
	I286CLOCK 8
	lea	ecx, [edi + ebx]
	call	@i286_memoryread_w@4
	cmp	word [I286_AX], ax
	FLAG_STORE_OF
	STRING_DIRx2
	add	bx, ax
	dec	word [I286_CX]
	je	.nzscasw_ed
	test	word [I286_FLAG], Z_FLAG
	je	.nzscasw_lp

.nzscasw_ed:
	mov	word [I286_DI], bx
.scasw_ed:
	ret
