#include	"compiler.h"

#include	"i286.h"

#ifdef I286_ASM
#include	"i286a.h"
#endif

#if defined(I286_C)
#include	"i286c.h"
#endif


	I286REGS	i286r;
	I286STAT	i286s;
	DTR_TABLE	GDTR;
	DTR_TABLE	IDTR;
	WORD		MSW;


void cpu_reset(void) {

	ZeroMemory(&i286r, sizeof(i286r));
	ZeroMemory(&i286s, sizeof(i286s));
	I286_CS = 0x1fc0;
	CS_BASE = 0x1fc00;
	ZeroMemory(&GDTR, sizeof(GDTR));
	ZeroMemory(&IDTR, sizeof(IDTR));
	MSW = 0;
}


void cpu_dump(int ip) {
	static char *flagstr[16][2] = {
				{NULL, NULL},		// 0x8000
				{NULL, NULL},		// 0x4000
				{NULL, NULL},		// 0x2000
				{NULL, NULL},		// 0x1000
				{"NV", "OV"},		// 0x0800
				{"DN", "UP"},		// 0x0400
				{"DI", "EI"},		// 0x0200
				{NULL, NULL},		// 0x0100
				{"PL", "NG"},		// 0x0080
				{"NZ", "ZR"},		// 0x0040
				{NULL, NULL},		// 0x0020
				{"NA", "AC"},		// 0x0010
				{NULL, NULL},		// 0x0008
				{"PO", "PE"},		// 0x0004
				{NULL, NULL},		// 0x0002
				{"NC", "CY"}};		// 0x0001

	char work[512];
	char w2[256];
	int i;
	WORD bit;
	WORD flag;

	sprintf(work, 
			"AX=%04x  BX=%04x  CX=%04x  DX=%04x  "		\
			"SP=%04x  BP=%04x  SI=%04x  DI=%04x\n"		\
			"DS=%04x  ES=%04x  SS=%04x  CS=%04x  "		\
			"IP=%04x   ",
			I286_AX, I286_BX, I286_CX, I286_DX,
			I286_SP, I286_BP, I286_SI, I286_DI,
			I286_DS, I286_ES, I286_SS, I286_CS,
			ip);

	flag = I286_FLAG;
	for (i=0, bit=0x8000; bit; i++, bit>>=1) {
		if (flagstr[i][0]) {
			if (flag & bit) {
				strcat(work, flagstr[i][1]);
			}
			else {
				strcat(work, flagstr[i][0]);
			}
			if (bit != 1) {
				strcat(work, " ");
			}
		}
	}
	strcat(work, "\n");

	wsprintf(w2, "DS=%08x ES=%08x SS=%08x CS=%08x\r\n",
									DS_BASE, ES_BASE, SS_BASE, CS_BASE);
	strcat(work, w2);

printf(work);
}
