#include	"compiler.h"

#include	"memory.h"
#include	"i286.h"
#include	"i286c_cf.h"
#include	"i286c_mn.h"
#include	"i286c.mcr"


// ---------------------------------------------------------------------------

static DWORD ea_bx_si(void) {

	return(((I286_BX + I286_SI) & 0x0000ffff) + DS_FIX);
}

static DWORD ea_bx_si_disp8(void) {

	long	adrs;

	GET_PCBYTESD(adrs);
	return(((adrs + I286_BX + I286_SI) & 0x0000ffff) + DS_FIX);
}

static DWORD ea_bx_si_disp16(void) {

	DWORD	adrs;

	GET_PCWORD(adrs);
	return(((adrs + I286_BX + I286_SI) & 0x0000ffff) + DS_FIX);
}

static DWORD ea_bx_di(void) {

	return(((I286_BX + I286_DI) & 0x0000ffff) + DS_FIX);
}

static DWORD ea_bx_di_disp8(void) {

	long	adrs;

	GET_PCBYTESD(adrs);
	return(((adrs + I286_BX + I286_DI) & 0x0000ffff) + DS_FIX);
}

static DWORD ea_bx_di_disp16(void) {

	DWORD	adrs;

	GET_PCWORD(adrs);
	return(((adrs + I286_BX + I286_DI) & 0x0000ffff) + DS_FIX);
}

static DWORD ea_bp_si(void) {

	return(((I286_BP + I286_SI) & 0x0000ffff) + SS_FIX);
}

static DWORD ea_bp_si_disp8(void) {

	long	adrs;

	GET_PCBYTESD(adrs);
	return(((adrs + I286_BP + I286_SI) & 0x0000ffff) + SS_FIX);
}

static DWORD ea_bp_si_disp16(void) {

	DWORD	adrs;

	GET_PCWORD(adrs);
	return(((adrs + I286_BP + I286_SI) & 0x0000ffff) + SS_FIX);
}

static DWORD ea_bp_di(void) {

	return(((I286_BP + I286_DI) & 0x0000ffff) + SS_FIX);
}

static DWORD ea_bp_di_disp8(void) {

	long	adrs;

	GET_PCBYTESD(adrs);
	return(((adrs + I286_BP + I286_DI) & 0x0000ffff) + SS_FIX);
}

static DWORD ea_bp_di_disp16(void) {

	DWORD	adrs;

	GET_PCWORD(adrs);
	return(((adrs + I286_BP + I286_DI) & 0x0000ffff) + SS_FIX);
}

static DWORD ea_si(void) {

	return(I286_SI + DS_FIX);
}

static DWORD ea_si_disp8(void) {

	long	adrs;

	GET_PCBYTESD(adrs);
	return(((adrs + I286_SI) & 0x0000ffff) + DS_FIX);
}

static DWORD ea_si_disp16(void) {

	DWORD	adrs;

	GET_PCWORD(adrs);
	return(((adrs + I286_SI) & 0x0000ffff) + DS_FIX);
}

static DWORD ea_di(void) {

	return(I286_DI + DS_FIX);
}

static DWORD ea_di_disp8(void) {

	long	adrs;

	GET_PCBYTESD(adrs);
	return(((adrs + I286_DI) & 0x0000ffff) + DS_FIX);
}

static DWORD ea_di_disp16(void) {

	DWORD	adrs;

	GET_PCWORD(adrs);
	return(((adrs + I286_DI) & 0x0000ffff) + DS_FIX);
}

static DWORD ea_disp16(void) {

	DWORD	adrs;

	GET_PCWORD(adrs);
	return((adrs & 0x0000ffff) + DS_FIX);
}

static DWORD ea_bp_disp8(void) {

	long	adrs;

	GET_PCBYTESD(adrs);
	return(((adrs + I286_BP) & 0x0000ffff) + SS_FIX);
}

static DWORD ea_bp_disp16(void) {

	DWORD	adrs;

	GET_PCWORD(adrs);
	return(((adrs + I286_BP) & 0x0000ffff) + SS_FIX);
}

static DWORD ea_bx(void) {

	return(I286_BX + DS_FIX);
}

static DWORD ea_bx_disp8(void) {

	long	adrs;

	GET_PCBYTESD(adrs);
	return(((adrs + I286_BX) & 0x0000ffff) + DS_FIX);
}

static DWORD ea_bx_disp16(void) {

	DWORD	adrs;

	GET_PCWORD(adrs);
	return(((adrs + I286_BX) & 0x0000ffff) + DS_FIX);
}

DWORD (*i286c_ea_dst_tbl[])(void) = {
			ea_bx_si,			ea_bx_di,
			ea_bp_si,			ea_bp_di,
			ea_si,				ea_di,
			ea_disp16,			ea_bx,
			ea_bx_si_disp8,		ea_bx_di_disp8,
			ea_bp_si_disp8,		ea_bp_di_disp8,
			ea_si_disp8,		ea_di_disp8,
			ea_bp_disp8,		ea_bx_disp8,
			ea_bx_si_disp16,	ea_bx_di_disp16,
			ea_bp_si_disp16,	ea_bp_di_disp16,
			ea_si_disp16,		ea_di_disp16,
			ea_bp_disp16,		ea_bx_disp16};


// --------------------------------------------------------------------------

static WORD lea_bx_si(void) {

	return(I286_BX + I286_SI);
}

static WORD lea_bx_si_disp8(void) {

	WORD	adrs;

	GET_PCBYTES(adrs);
	return(adrs + I286_BX + I286_SI);
}

static WORD lea_bx_si_disp16(void) {

	WORD	adrs;

	GET_PCWORD(adrs);
	return(adrs + I286_BX + I286_SI);
}

static WORD lea_bx_di(void) {

	return(I286_BX + I286_DI);
}

static WORD lea_bx_di_disp8(void) {

	WORD	adrs;

	GET_PCBYTES(adrs);
	return(adrs + I286_BX + I286_DI);
}

static WORD lea_bx_di_disp16(void) {

	WORD	adrs;

	GET_PCWORD(adrs);
	return(adrs + I286_BX + I286_DI);
}

static WORD lea_bp_si(void) {

	return(I286_BP + I286_SI);
}

static WORD lea_bp_si_disp8(void) {

	WORD	adrs;

	GET_PCBYTES(adrs);
	return(adrs + I286_BP + I286_SI);
}

static WORD lea_bp_si_disp16(void) {

	WORD	adrs;

	GET_PCWORD(adrs);
	return(adrs + I286_BP + I286_SI);
}

static WORD lea_bp_di(void) {

	return(I286_BP + I286_DI);
}

static WORD lea_bp_di_disp8(void) {

	WORD	adrs;

	GET_PCBYTES(adrs);
	return(adrs + I286_BP + I286_DI);
}

static WORD lea_bp_di_disp16(void) {

	WORD	adrs;

	GET_PCWORD(adrs);
	return(adrs + I286_BP + I286_DI);
}

static WORD lea_si(void) {

	return(I286_SI);
}

static WORD lea_si_disp8(void) {

	WORD	adrs;

	GET_PCBYTES(adrs);
	return(adrs + I286_SI);
}

static WORD lea_si_disp16(void) {

	WORD	adrs;

	GET_PCWORD(adrs);
	return(adrs + I286_SI);
}

static WORD lea_di(void) {

	return(I286_DI);
}

static WORD lea_di_disp8(void) {

	WORD	adrs;

	GET_PCBYTES(adrs);
	return(adrs + I286_DI);
}

static WORD lea_di_disp16(void) {

	WORD	adrs;

	GET_PCWORD(adrs);
	return(adrs + I286_DI);
}

static WORD lea_disp16(void) {

	WORD	adrs;

	GET_PCWORD(adrs);
	return(adrs);
}

static WORD lea_bp_disp8(void) {

	WORD	adrs;

	GET_PCBYTES(adrs);
	return(adrs + I286_BP);
}

static WORD lea_bp_disp16(void) {

	WORD	adrs;

	GET_PCWORD(adrs);
	return(adrs + I286_BP);
}

static WORD lea_bx(void) {

	return(I286_BX);
}

static WORD lea_bx_disp8(void) {

	WORD	adrs;

	GET_PCBYTES(adrs);
	return(adrs + I286_BX);
}

static WORD lea_bx_disp16(void) {

	WORD	adrs;

	GET_PCWORD(adrs);
	return(adrs + I286_BX);
}

WORD (*i286c_lea_tbl[])(void) = {
			lea_bx_si,			lea_bx_di,
			lea_bp_si,			lea_bp_di,
			lea_si,				lea_di,
			lea_disp16,			lea_bx,
			lea_bx_si_disp8,	lea_bx_di_disp8,
			lea_bp_si_disp8,	lea_bp_di_disp8,
			lea_si_disp8,		lea_di_disp8,
			lea_bp_disp8,		lea_bx_disp8,
			lea_bx_si_disp16,	lea_bx_di_disp16,
			lea_bp_si_disp16,	lea_bp_di_disp16,
			lea_si_disp16,		lea_di_disp16,
			lea_bp_disp16,		lea_bx_disp16};

// --------------------------------------------------------------------------

static WORD a_bx_si(void) {

	EA_FIX = DS_FIX;
	return(I286_BX + I286_SI);
}

static WORD a_bx_si_disp8(void) {

	WORD	adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTES(adrs);
	return(adrs + I286_BX + I286_SI);
}

static WORD a_bx_si_disp16(void) {

	WORD	adrs;

	EA_FIX = DS_FIX;
	GET_PCWORD(adrs);
	return(adrs + I286_BX + I286_SI);
}

static WORD a_bx_di(void) {

	EA_FIX = DS_FIX;
	return(I286_BX + I286_DI);
}

static WORD a_bx_di_disp8(void) {

	WORD	adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTES(adrs);
	return(adrs + I286_BX + I286_DI);
}

static WORD a_bx_di_disp16(void) {

	WORD	adrs;

	EA_FIX = DS_FIX;
	GET_PCWORD(adrs);
	return(adrs + I286_BX + I286_DI);
}

static WORD a_bp_si(void) {

	EA_FIX = SS_FIX;
	return(I286_BP + I286_SI);
}

static WORD a_bp_si_disp8(void) {

	WORD	adrs;

	EA_FIX = SS_FIX;
	GET_PCBYTES(adrs);
	return(adrs + I286_BP + I286_SI);
}

static WORD a_bp_si_disp16(void) {

	WORD	adrs;

	EA_FIX = SS_FIX;
	GET_PCWORD(adrs);
	return(adrs + I286_BP + I286_SI);
}

static WORD a_bp_di(void) {

	EA_FIX = SS_FIX;
	return(I286_BP + I286_DI);
}

static WORD a_bp_di_disp8(void) {

	WORD	adrs;

	EA_FIX = SS_FIX;
	GET_PCBYTES(adrs);
	return(adrs + I286_BP + I286_DI);
}

static WORD a_bp_di_disp16(void) {

	WORD	adrs;

	EA_FIX = SS_FIX;
	GET_PCWORD(adrs);
	return(adrs + I286_BP + I286_DI);
}

static WORD a_si(void) {

	EA_FIX = DS_FIX;
	return(I286_SI);
}

static WORD a_si_disp8(void) {

	WORD	adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTES(adrs);
	return(adrs + I286_SI);
}

static WORD a_si_disp16(void) {

	WORD	adrs;

	EA_FIX = DS_FIX;
	GET_PCWORD(adrs);
	return(adrs + I286_SI);
}

static WORD a_di(void) {

	EA_FIX = DS_FIX;
	return(I286_DI);
}

static WORD a_di_disp8(void) {

	WORD	adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTES(adrs);
	return(adrs + I286_DI);
}

static WORD a_di_disp16(void) {

	WORD	adrs;

	EA_FIX = DS_FIX;
	GET_PCWORD(adrs);
	return(adrs + I286_DI);
}

static WORD a_disp16(void) {

	WORD	adrs;

	EA_FIX = DS_FIX;
	GET_PCWORD(adrs);
	return(adrs);
}

static WORD a_bp_disp8(void) {

	WORD	adrs;

	EA_FIX = SS_FIX;
	GET_PCBYTESD(adrs);
	return(adrs + I286_BP);
}

static WORD a_bp_disp16(void) {

	WORD	adrs;

	EA_FIX = SS_FIX;
	GET_PCWORD(adrs);
	return(adrs + I286_BP);
}

static WORD a_bx(void) {

	EA_FIX = DS_FIX;
	return(I286_BX);
}

static WORD a_bx_disp8(void) {

	WORD	adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTES(adrs);
	return(adrs + I286_BX);
}

static WORD a_bx_disp16(void) {

	WORD	adrs;

	EA_FIX = DS_FIX;
	GET_PCWORD(adrs);
	return(adrs + I286_BX);
}

WORD (*i286c_ea_tbl[])(void) = {
			a_bx_si,			a_bx_di,
			a_bp_si,			a_bp_di,
			a_si,				a_di,
			a_disp16,			a_bx,
			a_bx_si_disp8,		a_bx_di_disp8,
			a_bp_si_disp8,		a_bp_di_disp8,
			a_si_disp8,			a_di_disp8,
			a_bp_disp8,			a_bx_disp8,
			a_bx_si_disp16,		a_bx_di_disp16,
			a_bp_si_disp16,		a_bp_di_disp16,
			a_si_disp16,		a_di_disp16,
			a_bp_disp16,		a_bx_disp16};




#if 0
// --------------------------------------------------------------- endtest.cpp
static BYTE getb(void) {
	return(0xff);
}
static WORD getw(void) {
	return(0xffff);
}

BOOL endiantest(void) {

	long	l;

	l = __CBW(getb());
	if (l != 0x0000ffff) {
		return(FAILURE);
	}
	l = __CBD(getw());
	if (l != 0xffffffff) {
		return(FAILURE);
	}
	l = WORD2LONG(getw());
	if (l != 0xffffffff) {
		return(FAILURE);
	}
	return(SUCCESS);
}


// ---------------------------------------------------------------------------
void i286ea_inittable(void) {

	int		i;
	int		pos;
	BYTE	f;
	DWORD	bit;

	for (i=0; i<0x100; i++) {
		pos = ((i & 0x20)?1:0);
		pos += ((i >> 3) & 3) * 2;
		reg8_b53[i] = ((BYTE *)&i286r) + pos;
		pos = ((i & 0x4)?1:0);
		pos += (i & 3) * 2;
		reg8_b20[i] = ((BYTE *)&i286r) + pos;
		reg16_b53[i] = ((WORD *)&i286r) + ((i >> 3) & 7);
		reg16_b20[i] = ((WORD *)&i286r) + (i & 7);
	}

	for (i=0; i<0xc0; i++) {
		pos = ((i >> 3) & 0x18) + (i & 0x07);
		c_calc_ea_dst[i] = ea_dst_tbl[pos];
		c_calc_lea[i] = lea_tbl[pos];
		c_get_ea[i] = ea_tbl[pos];
	}
	for (; i<0x100; i++) {
		c_calc_ea_dst[i] = ea_nop;
	}

	for (i=0; i<0x100; i++) {
		f = P_FLAG;
		for (bit=0x80; bit; bit>>=1) {
			if (i & bit) {
				f ^= P_FLAG;
			}
		}
		if (!(i & 0xff)) {
			f |= Z_FLAG;
		}
		if (i & 0x80) {
			f |= S_FLAG;
		}
		szpcflag[i+0x000] = f;
		szpcflag[i+0x100] = f | C_FLAG;
	}
	for (i=0; i<0x10000; i++) {
		f = P_FLAG;
		for (bit=0x80; bit; bit>>=1) {
			if (i & bit) {
				f ^= P_FLAG;
			}
		}
		if (!i) {
			f |= Z_FLAG;
		}
		if (i & 0x8000) {
			f |= S_FLAG;
		}
		szpflag_w[i] = f;
	}




	if (endiantest()) {
		MessageBox(NULL, "Bad work!", "endian test...", MB_OK);
	}
}
#endif
