
; BIT AND BYTE INSTRUCTIONS

%include "cpu.inc"
%include "cpu.mcr"
%include "misc.inc"
%include "resolve.inc"

extern	_cpu_regs
extern	cpu_inst

section .text

; bit test
; bt
	align	32
	global	BT_EwGw
BT_EwGw:
				PREPART_EA_REG16 2
					and		dx, 0fh
					bt		[CPU_REG + eax * 4], dx
					FLAG_STORE_C
					ret
				.memory_eareg16:
					CPUCLOCK 7
					rol		al, 2
					and		eax, 1fh
					call	calc_ea_dst
					mov		bx, [CPU_REG + ebx * 4]
					movsx	edx, bx
					and		bx, 0fh
					sar		edx, 3
					and		edx, ~1
					add		ecx, edx
					cmp		ecx, MAINMEM_WRITEMAX - 1
					jae		.extmem_eareg16
					bt		[MAIN_MEM + ecx], bx
					FLAG_STORE_C
					ret
				EXTMEM_EA_REG16
					bt		dx, bx
					FLAG_STORE_C
					ret

	align	32
	global	BT_EdGd
BT_EdGd:
				PREPART_EA_REG32 2
					and		edx, 1fh
					bt		[CPU_REG + eax * 4], edx
					FLAG_STORE_C
					ret
				.memory_eareg32:
					CPUCLOCK 7
					rol		al, 2
					and		eax, 1fh
					call	calc_ea_dst
					mov		ebx, [CPU_REG + ebx * 4]
					mov		edx, ebx
					and		ebx, 1fh
					sar		edx, 3
					and		edx, ~3
					add		ecx, edx
					cmp		ecx, MAINMEM_WRITEMAX - 3
					jae		.extmem_eareg32
					bt		[MAIN_MEM + ecx], ebx
					FLAG_STORE_C
					ret
				EXTMEM_EA_REG32
					bt		edx, ebx
					FLAG_STORE_C
					ret

	align	32
	global	BT_EwIb
BT_EwIb:
				PREPART_EA16 2
					mov		ebx, eax
					GET_PCBYTE
					and		ax, 0fh
					bt		[CPU_REG + ebx * 4], ax
					FLAG_STORE_C
					ret
				MEMORY_EA16 6
					mov		ebx, ecx
					GET_PCBYTE
					and		ax, 0fh
					bt		[MAIN_MEM + ebx], ax
					FLAG_STORE_C
					ret
				EXTMEM_EA16
					mov		dx, ax
					GET_PCBYTE
					and		ax, 0fh
					bt		dx, ax
					FLAG_STORE_C
					ret

	align	32
	global	BT_EdIb
BT_EdIb:
				PREPART_EA32 2
					mov		ebx, eax
					GET_PCBYTE
					and		eax, 1fh
					bt		[CPU_REG + ebx * 4], eax
					FLAG_STORE_C
					ret
				MEMORY_EA32 6
					mov		ebx, ecx
					GET_PCBYTE
					and		eax, 1fh
					bt		[MAIN_MEM + ebx], eax
					FLAG_STORE_C
					ret
				EXTMEM_EA32
					mov		edx, eax
					GET_PCBYTE
					and		eax, 1fh
					bt		edx, eax
					FLAG_STORE_C
					ret

; bts
	align	32
	global	BTS_EwGw
BTS_EwGw:
				PREPART_EA_REG16 2
					and		dx, 0fh
					bts		[CPU_REG + eax * 4], dx
					FLAG_STORE_C
					ret
				.memory_eareg16:
					CPUCLOCK 7
					rol		al, 2
					and		eax, 1fh
					call	calc_ea_dst
					mov		bx, [CPU_REG + ebx * 4]
					movsx	edx, bx
					and		bx, 0fh
					sar		edx, 3
					and		edx, ~1
					add		ecx, edx
					cmp		ecx, MAINMEM_WRITEMAX - 1
					jae		.extmem_eareg16
					bts		[MAIN_MEM + ecx], bx
					FLAG_STORE_C
					ret
				EXTMEM_EA_REG16
					bts		dx, bx
					FLAG_STORE_C
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	BTS_EdGd
BTS_EdGd:
				PREPART_EA_REG32 2
					and		edx, 1fh
					bts		[CPU_REG + eax * 4], edx
					FLAG_STORE_C
					ret
				.memory_eareg32:
					CPUCLOCK 7
					rol		al, 2
					and		eax, 1fh
					call	calc_ea_dst
					mov		ebx, [CPU_REG + ebx * 4]
					mov		edx, ebx
					and		ebx, 1fh
					sar		edx, 3
					and		edx, ~3
					add		ecx, edx
					cmp		ecx, MAINMEM_WRITEMAX - 3
					jae		.extmem_eareg32
					bts		[MAIN_MEM + ecx], ebx
					FLAG_STORE_C
					ret
				EXTMEM_EA_REG32
					bts		edx, ebx
					FLAG_STORE_C
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	BTS_EwIb
BTS_EwIb:
				PREPART_EA16 2
					mov		ebx, eax
					GET_PCBYTE
					and		ax, 0fh
					bts		[CPU_REG + ebx * 4], ax
					FLAG_STORE_C
					ret
				MEMORY_EA16 6
					mov		ebx, ecx
					GET_PCBYTE
					and		ax, 0fh
					bts		[MAIN_MEM + ebx], ax
					FLAG_STORE_C
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					and		ax, 0fh
					mov		ecx, ebx
					bts		dx, ax
					FLAG_STORE_C
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	BTS_EdIb
BTS_EdIb:
				PREPART_EA32 2
					mov		ebx, eax
					GET_PCBYTE
					and		eax, 1fh
					bts		[CPU_REG + ebx * 4], eax
					FLAG_STORE_C
					ret
				MEMORY_EA32 6
					mov		ebx, ecx
					GET_PCBYTE
					and		eax, 1fh
					bts		[MAIN_MEM + ebx], eax
					FLAG_STORE_C
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					and		eax, 1fh
					mov		ecx, ebx
					bts		edx, eax
					FLAG_STORE_C
					jmp		__f_i286_memorywrite_d@8

; btr
	align	32
	global	BTR_EwGw
BTR_EwGw:
				PREPART_EA_REG16 2
					and		dx, 0fh
					btr		[CPU_REG + eax * 4], dx
					FLAG_STORE_C
					ret
				.memory_eareg16:
					CPUCLOCK 7
					rol		al, 2
					and		eax, 1fh
					call	calc_ea_dst
					mov		bx, [CPU_REG + ebx * 4]
					movsx	edx, bx
					and		bx, 0fh
					sar		edx, 3
					and		edx, ~1
					add		ecx, edx
					cmp		ecx, MAINMEM_WRITEMAX - 1
					jae		.extmem_eareg16
					btr		[MAIN_MEM + ecx], bx
					FLAG_STORE_C
					ret
				EXTMEM_EA_REG16
					btr		dx, bx
					FLAG_STORE_C
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	BTR_EdGd
BTR_EdGd:
				PREPART_EA_REG32 2
					and		edx, 1fh
					btr		[CPU_REG + eax * 4], edx
					FLAG_STORE_C
					ret
				.memory_eareg32:
					CPUCLOCK 7
					rol		al, 2
					and		eax, 1fh
					call	calc_ea_dst
					mov		ebx, [CPU_REG + ebx * 4]
					mov		edx, ebx
					and		ebx, 1fh
					sar		edx, 3
					and		edx, ~3
					add		ecx, edx
					cmp		ecx, MAINMEM_WRITEMAX - 3
					jae		.extmem_eareg32
					btr		[MAIN_MEM + ecx], ebx
					FLAG_STORE_C
					ret
				EXTMEM_EA_REG32
					btr		edx, ebx
					FLAG_STORE_C
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	BTR_EwIb
BTR_EwIb:
				PREPART_EA16 2
					mov		ebx, eax
					GET_PCBYTE
					and		ax, 0fh
					btr		[CPU_REG + ebx * 4], ax
					FLAG_STORE_C
					ret
				MEMORY_EA16 6
					mov		ebx, ecx
					GET_PCBYTE
					and		ax, 0fh
					btr		[MAIN_MEM + ebx], ax
					FLAG_STORE_C
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					and		ax, 0fh
					mov		ecx, ebx
					btr		dx, ax
					FLAG_STORE_C
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	BTR_EdIb
BTR_EdIb:
				PREPART_EA32 2
					mov		ebx, eax
					GET_PCBYTE
					and		eax, 1fh
					btr		[CPU_REG + ebx * 4], eax
					FLAG_STORE_C
					ret
				MEMORY_EA32 6
					mov		ebx, ecx
					GET_PCBYTE
					and		eax, 1fh
					btr		[MAIN_MEM + ebx], eax
					FLAG_STORE_C
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					and		eax, 1fh
					mov		ecx, ebx
					btr		edx, eax
					FLAG_STORE_C
					jmp		__f_i286_memorywrite_d@8

; btc
	align	32
	global	BTC_EwGw
BTC_EwGw:
				PREPART_EA_REG16 2
					and		dx, 0fh
					btc		[CPU_REG + eax * 4], dx
					FLAG_STORE_C
					ret
				.memory_eareg16:
					CPUCLOCK 7
					rol		al, 2
					and		eax, 1fh
					call	calc_ea_dst
					mov		bx, [CPU_REG + ebx * 4]
					movsx	edx, bx
					and		bx, 0fh
					sar		edx, 3
					and		edx, ~1
					add		ecx, edx
					cmp		ecx, MAINMEM_WRITEMAX - 1
					jae		.extmem_eareg16
					btc		[MAIN_MEM + ecx], bx
					FLAG_STORE_C
					ret
				EXTMEM_EA_REG16
					btc		dx, bx
					FLAG_STORE_C
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	BTC_EdGd
BTC_EdGd:
				PREPART_EA_REG32 2
					and		edx, 1fh
					btc		[CPU_REG + eax * 4], edx
					FLAG_STORE_C
					ret
				.memory_eareg32:
					CPUCLOCK 7
					rol		al, 2
					and		eax, 1fh
					call	calc_ea_dst
					mov		ebx, [CPU_REG + ebx * 4]
					mov		edx, ebx
					and		ebx, 1fh
					sar		edx, 3
					and		edx, ~3
					add		ecx, edx
					cmp		ecx, MAINMEM_WRITEMAX - 3
					jae		.extmem_eareg32
					btc		[MAIN_MEM + ecx], ebx
					FLAG_STORE_C
					ret
				EXTMEM_EA_REG32
					btc		edx, ebx
					FLAG_STORE_C
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	BTC_EwIb
BTC_EwIb:
				PREPART_EA16 2
					mov		ebx, eax
					GET_PCBYTE
					and		ax, 0fh
					btc		[CPU_REG + ebx * 4], ax
					FLAG_STORE_C
					ret
				MEMORY_EA16 6
					mov		ebx, ecx
					GET_PCBYTE
					and		ax, 0fh
					btc		[MAIN_MEM + ebx], ax
					FLAG_STORE_C
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					and		ax, 0fh
					mov		ecx, ebx
					btc		dx, ax
					FLAG_STORE_C
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	BTC_EdIb
BTC_EdIb:
				PREPART_EA32 2
					mov		ebx, eax
					GET_PCBYTE
					and		eax, 1fh
					btc		[CPU_REG + ebx * 4], eax
					FLAG_STORE_C
					ret
				MEMORY_EA32 6
					mov		ebx, ecx
					GET_PCBYTE
					and		eax, 1fh
					btc		[MAIN_MEM + ebx], eax
					FLAG_STORE_C
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					and		eax, 1fh
					mov		ecx, ebx
					btc		edx, eax
					FLAG_STORE_C
					jmp		__f_i286_memorywrite_d@8

; bit scan
	align	32
	global	BSF_GwEw
BSF_GwEw:
				PREPART_REG16_EA 2, 7
					bsf		dx, ax
					mov		[CPU_REG + ebx * 4], dx
					FLAG_STORE_Z
					ret

	align	32
	global	BSF_GdEd
BSF_GdEd:
				PREPART_REG32_EA 2, 7
					bsf		edx, eax
					mov		[CPU_REG + ebx * 4], edx
					FLAG_STORE_Z
					ret

	align	32
	global	BSR_GwEw
BSR_GwEw:
				PREPART_REG16_EA 2, 7
					bsr		dx, ax
					mov		[CPU_REG + ebx * 4], dx
					FLAG_STORE_Z
					ret

	align	32
	global	BSR_GdEd
BSR_GdEd:
				PREPART_REG32_EA 2, 7
					bsr		edx, eax
					mov		[CPU_REG + ebx * 4], edx
					FLAG_STORE_Z
					ret

; set byte
	align	32
	global	SETO_Eb
SETO_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					test	word [CPU_FLAG], O_FLAG
					setnz	[CPU_REG + eax]
					ret
				MEMORY_EA8 3
					test	word [CPU_FLAG], O_FLAG
					setnz	[MAIN_MEM + ecx]
					ret
				.extmem_eareg8:
					test	word [CPU_FLAG], O_FLAG
					setnz	dl
					jmp		__f_i286_memorywrite@8

	align	32
	global	SETNO_Eb
SETNO_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					test	word [CPU_FLAG], O_FLAG
					setz	[CPU_REG + eax]
					ret
				MEMORY_EA8 3
					test	word [CPU_FLAG], O_FLAG
					setz	[MAIN_MEM + ecx]
					ret
				.extmem_eareg8:
					test	word [CPU_FLAG], O_FLAG
					setz	dl
					jmp		__f_i286_memorywrite@8

	align	32
	global	SETC_Eb
SETC_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					test	byte [CPU_FLAGL], C_FLAG
					setnz	[CPU_REG + eax]
					ret
				MEMORY_EA8 3
					test	byte [CPU_FLAGL], C_FLAG
					setnz	[MAIN_MEM + ecx]
					ret
				.extmem_eareg8:
					test	byte [CPU_FLAGL], C_FLAG
					setnz	dl
					jmp		__f_i286_memorywrite@8

	align	32
	global	SETNC_Eb
SETNC_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					test	byte [CPU_FLAGL], C_FLAG
					setz	[CPU_REG + eax]
					ret
				MEMORY_EA8 3
					test	byte [CPU_FLAGL], C_FLAG
					setz	[MAIN_MEM + ecx]
					ret
				.extmem_eareg8:
					test	byte [CPU_FLAGL], C_FLAG
					setz	dl
					jmp		__f_i286_memorywrite@8

	align	32
	global	SETZ_Eb
SETZ_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					test	byte [CPU_FLAGL], Z_FLAG
					setnz	[CPU_REG + eax]
					ret
				MEMORY_EA8 3
					test	byte [CPU_FLAGL], Z_FLAG
					setnz	[MAIN_MEM + ecx]
					ret
				.extmem_eareg8:
					test	byte [CPU_FLAGL], Z_FLAG
					setnz	dl
					jmp		__f_i286_memorywrite@8

	align	32
	global	SETNZ_Eb
SETNZ_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					test	byte [CPU_FLAGL], Z_FLAG
					setz	[CPU_REG + eax]
					ret
				MEMORY_EA8 3
					test	byte [CPU_FLAGL], Z_FLAG
					setz	[MAIN_MEM + ecx]
					ret
				.extmem_eareg8:
					test	byte [CPU_FLAGL], Z_FLAG
					setz	dl
					jmp		__f_i286_memorywrite@8

	align	32
	global	SETNA_Eb
SETNA_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
					setnz	[CPU_REG + eax]
					ret
				MEMORY_EA8 3
					test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
					setnz	[MAIN_MEM + ecx]
					ret
				.extmem_eareg8:
					test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
					setnz	dl
					jmp		__f_i286_memorywrite@8

	align	32
	global	SETA_Eb
SETA_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
					setz	[CPU_REG + eax]
					ret
				MEMORY_EA8 3
					test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
					setz	[MAIN_MEM + ecx]
					ret
				.extmem_eareg8:
					test	byte [CPU_FLAGL], Z_FLAG | C_FLAG
					setz	dl
					jmp		__f_i286_memorywrite@8

	align	32
	global	SETS_Eb
SETS_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					test	byte [CPU_FLAGL], S_FLAG
					setnz	[CPU_REG + eax]
					ret
				MEMORY_EA8 3
					test	byte [CPU_FLAGL], S_FLAG
					setnz	[MAIN_MEM + ecx]
					ret
				.extmem_eareg8:
					test	byte [CPU_FLAGL], S_FLAG
					setnz	dl
					jmp		__f_i286_memorywrite@8

	align	32
	global	SETNS_Eb
SETNS_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					test	byte [CPU_FLAGL], S_FLAG
					setz	[CPU_REG + eax]
					ret
				MEMORY_EA8 3
					test	byte [CPU_FLAGL], S_FLAG
					setz	[MAIN_MEM + ecx]
					ret
				.extmem_eareg8:
					test	byte [CPU_FLAGL], S_FLAG
					setz	dl
					jmp		__f_i286_memorywrite@8

	align	32
	global	SETP_Eb
SETP_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					test	byte [CPU_FLAGL], P_FLAG
					setnz	[CPU_REG + eax]
					ret
				MEMORY_EA8 3
					test	byte [CPU_FLAGL], P_FLAG
					setnz	[MAIN_MEM + ecx]
					ret
				.extmem_eareg8:
					test	byte [CPU_FLAGL], P_FLAG
					setnz	dl
					jmp		__f_i286_memorywrite@8

	align	32
	global	SETNP_Eb
SETNP_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					test	byte [CPU_FLAGL], P_FLAG
					setz	[CPU_REG + eax]
					ret
				MEMORY_EA8 3
					test	byte [CPU_FLAGL], P_FLAG
					setz	[MAIN_MEM + ecx]
					ret
				.extmem_eareg8:
					test	byte [CPU_FLAGL], P_FLAG
					setz	dl
					jmp		__f_i286_memorywrite@8

	align	32
	global	SETL_Eb
SETL_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dl, dh
					sets	[CPU_REG + eax]
					ret
				MEMORY_EA8 3
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dl, dh
					sets	[MAIN_MEM + ecx]
					ret
				.extmem_eareg8:
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dl, dh
					sets	dl
					jmp		__f_i286_memorywrite@8

	align	32
	global	SETNL_Eb
SETNL_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dl, dh
					setns	[CPU_REG + eax]
					ret
				MEMORY_EA8 3
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dl, dh
					setns	[MAIN_MEM + ecx]
					ret
				.extmem_eareg8:
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dl, dh
					setns	dl
					jmp		__f_i286_memorywrite@8

	align	32
	global	SETLE_Eb
SETLE_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dh, dl
					sets	dh
					bt		dx, 6
					setc	dl
					or		dl, dh
					mov		[CPU_REG + eax], dl
					ret
				MEMORY_EA8 3
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dh, dl
					sets	dh
					bt		dx, 6
					setc	dl
					or		dl, dh
					mov		[MAIN_MEM + ecx], dl
					ret
				.extmem_eareg8:
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dh, dl
					sets	dh
					bt		dx, 6
					setc	dl
					or		dl, dh
					jmp		__f_i286_memorywrite@8

	align	32
	global	SETNLE_Eb
SETNLE_Eb:
				GET_PCBYTE
				PREPART_EA8 2
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dh, dl
					setns	dh
					bt		dx, 6
					setnc	dl
					and		dl, dh
					mov		[CPU_REG + eax], dl
					ret
				MEMORY_EA8 3
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dh, dl
					setns	dh
					bt		dx, 6
					setnc	dl
					and		dl, dh
					mov		[MAIN_MEM + ecx], dl
					ret
				.extmem_eareg8:
					mov		dx, [CPU_FLAG]
					shl		dh, 4
					xor		dh, dl
					setns	dh
					bt		dx, 6
					setnc	dl
					and		dl, dh
					jmp		__f_i286_memorywrite@8

; test
	align	32
	global	TEST_EbGb
TEST_EbGb:
				PREPART_EA_REG8 2
					test	[CPU_REG + eax], dl
					FLAG_STORE0
					ret
				MEMORY_EA_REG8 7
					test	[MAIN_MEM + ecx], dl
					FLAG_STORE0
					ret
				EXTMEM_EA_REG8
					test	al, [CPU_REG + ebx]
					FLAG_STORE0
					ret

	align	32
	global	TEST_EwGw
TEST_EwGw:
				PREPART_EA_REG16 2
					test	[CPU_REG + eax * 4], dx
					FLAG_STORE0
					ret
				MEMORY_EA_REG16 6
					test	[MAIN_MEM + ecx], dx
					FLAG_STORE0
					ret
				EXTMEM_EA_REG16
					test	ax, [CPU_REG + ebx * 4]
					FLAG_STORE0
					ret

	align	32
	global	TEST_EdGd
TEST_EdGd:
				PREPART_EA_REG32 2
					test	[CPU_REG + eax * 4], edx
					FLAG_STORE0
					ret
				MEMORY_EA_REG32 6
					test	[MAIN_MEM + ecx], edx
					FLAG_STORE0
					ret
				EXTMEM_EA_REG32
					test	eax, [CPU_REG + ebx * 4]
					FLAG_STORE0
					ret

	align	32
	global	TEST_ALIb
TEST_ALIb:
				CPUCLOCK 3
				GET_PCBYTE
				test	[CPU_AL], al
				FLAG_STORE0
				ret

	align	32
	global	TEST_AXIw
TEST_AXIw:
				CPUCLOCK 3
				GET_PCWORD
				test	[CPU_AX], ax
				FLAG_STORE0
				ret

	align	32
	global	TEST_EAXId
TEST_EAXId:
				CPUCLOCK 3
				GET_PCDWORD
				test	[CPU_EAX], eax
				FLAG_STORE0
				ret

	align	32
	global	TEST_EbIb
TEST_EbIb:
				PREPART_EA8 2
					mov		bl, [CPU_REG + eax]
					GET_PCBYTE
					test	bl, al
					FLAG_STORE0
					ret
				MEMORY_EA8 6
					mov		bl, [MAIN_MEM + ecx]
					GET_PCBYTE
					test	bl, al
					FLAG_STORE0
					ret
				EXTMEM_EA8
					mov		dl, al
					GET_PCBYTE
					test	dl, al
					FLAG_STORE0
					ret

	align	32
	global	TEST_EwIw
TEST_EwIw:
				PREPART_EA16 2
					mov		bx, [CPU_REG + eax * 4]
					GET_PCWORD
					test	bx, ax
					FLAG_STORE0
					ret
				MEMORY_EA16 6
					mov		bx, [MAIN_MEM + ecx]
					GET_PCWORD
					test	bx, ax
					FLAG_STORE0
					ret
				EXTMEM_EA16
					mov		dx, ax
					GET_PCWORD
					test	dx, ax
					FLAG_STORE0
					ret

	align	32
	global	TEST_EdId
TEST_EdId:
				PREPART_EA32 2
					mov		ebx, [CPU_REG + eax * 4]
					GET_PCDWORD
					test	ebx, eax
					FLAG_STORE0
					ret
				MEMORY_EA32 6
					mov		ebx, [MAIN_MEM + ecx]
					GET_PCDWORD
					test	ebx, eax
					FLAG_STORE0
					ret
				EXTMEM_EA32
					mov		edx, eax
					GET_PCDWORD
					test	edx, eax
					FLAG_STORE0
					ret

