
; FLAG CONTROL INSTRUCTIONS

%include "cpu.inc"
%include "cpu.mcr"
%include "misc.inc"
%include "debug.inc"

extern	_cpu_regs
extern	_cpu_stat

extern	exec_1step

section .text

;
	align	32
	global	_STC
_STC:
				CPUCLOCK 2
				or		byte [CPU_FLAGL], C_FLAG
				ret

	align	32
	global	_CLC
_CLC:
				CPUCLOCK 2
				and		byte [CPU_FLAGL], ~ C_FLAG
				ret

	align	32
	global	_CMC
_CMC:
				CPUCLOCK 2
				xor		byte [CPU_FLAGL], C_FLAG
				ret

	align	32
	global	_CLD
_CLD:
				CPUCLOCK 2
				and		word [CPU_FLAG], ~ D_FLAG
				ret

	align	32
	global	_STD
_STD:
				CPUCLOCK 2
				or		word [CPU_FLAG], D_FLAG
				ret

; eflags <-> ah
	align	32
	global	_LAHF
_LAHF:
				CPUCLOCK 2
				mov		al, [CPU_FLAGL]
				mov		[CPU_AH], al
				ret

	align	32
	global	_SAHF
_SAHF:
				CPUCLOCK 2
				mov		al, [CPU_AH]
				and		al, 0d7h
				or		al, 02h
				mov		[CPU_FLAGL], al
				ret

; push/pop eflags
	align	32
	global	PUSHF_Fw
PUSHF_Fw:
				CPUCLOCK 3
				REGPUSH1 [CPU_FLAG]

	align	32
	global	PUSHFD_Fd
PUSHFD_Fd:
				CPUCLOCK 3
				mov		edx, [CPU_EFLAG]
				and		edx, 00fcffffh
				sub		word [CPU_SP], 4
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				jmp		__f_i286_memorywrite_d@8

	align	32
	global	POPF_Fw
POPF_Fw:
				CPUCLOCK 5
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				call	__f_i286_memoryread_w@4
				add		word [CPU_SP], 2
				and		ax, 7fd7h
				or		ax, 0002h
				mov		[CPU_FLAG], ax
				and		ah, 3
				cmp		ah, 3
				sete	[CPU_TRAP]
				IRQCHECKTERM

	align	32
	global	POPFD_Fd
POPFD_Fd:
				CPUCLOCK 5
				movzx	ecx, word [CPU_SP]
				add		ecx, [SS_BASE]
				call	__f_i286_memoryread_d@4
				add		word [CPU_SP], 4
				and		eax, 00277fd7h
				or		eax, 00000002h
				mov		[CPU_EFLAG], eax
				test	eax, VM_FLAG
				jnz		.vm
				and		ah, 3
				cmp		ah, 3
				sete	[CPU_TRAP]
				IRQCHECKTERM

		.vm:	jmp		__f_change_vm@0

;
	align	32
	global	_STI
_STI:
				CPUCLOCK 2
				or		word [CPU_FLAG], I_FLAG
				test	word [CPU_FLAG], T_FLAG
				setne	[CPU_TRAP]
				call	exec_1step
				IRQCHECKTERM

	align	32
	global	_CLI
_CLI:
				CPUCLOCK 2
				and		word [CPU_FLAG], ~ I_FLAG
				mov		byte [CPU_TRAP], 0
				ret

