
%include "cpu.inc"
%include "cpu.mcr"

section	.text

	align	32
_nop:
				ret

; mod: 00
	align	32
_eax:
				mov		ebx, [CPU_EAX]
				GET_PREFIX_DS

	align	32
_ecx:
				mov		ebx, [CPU_ECX]
				GET_PREFIX_DS

	align	32
_edx:
				mov		ebx, [CPU_EDX]
				GET_PREFIX_DS

	align	32
_ebx:
				mov		ebx, [CPU_EBX]
				GET_PREFIX_DS

	align	32
sib:
				GET_PCBYTE		; sib
				mov		dl, al
				and		eax, 7		; base
				cmp		al, 4
				je		.base4
				cmp		al, 5
				je		.base5

				mov		ebx, [CPU_REG + eax * 4]
				mov		cl, dl
				shr		cl, 6		; scale
				shr		dl, 3
				and		edx, 7		; index
				call	[sib_table + edx * 4]
				GET_PREFIX_DS

	.base4:		mov		ebx, [CPU_ESP]
				mov		cl, dl
				shr		cl, 6		; scale
				shr		dl, 3
				and		edx, 7		; index
				call	[sib_table + edx * 4]
				GET_PREFIX_SS

	.base5:		GET_PCDWORD		; disp32
				mov		ebx, eax
				mov		cl, dl
				shr		cl, 6		; scale
				shr		dl, 3
				and		edx, 7		; index
				call	[sib_table + edx * 4]
				GET_PREFIX_DS

	align	32
disp32:
				GET_PCDWORD		; disp32
				mov		ebx, eax
				GET_PREFIX_DS

	align	32
_esi:
				mov		ebx, [CPU_ESI]
				GET_PREFIX_DS

	align	32
_edi:
				mov		ebx, [CPU_EDI]
				GET_PREFIX_DS

; mod: 01
	align	32
eax_disp8:
				GET_PCBYTE
				movsx	ebx, al
				add		ebx, [CPU_EAX]
				GET_PREFIX_DS

	align	32
ecx_disp8:
				GET_PCBYTE
				movsx	ebx, al
				add		ebx, [CPU_ECX]
				GET_PREFIX_DS

	align	32
edx_disp8:
				GET_PCBYTE
				movsx	ebx, al
				add		ebx, [CPU_EDX]
				GET_PREFIX_DS

	align	32
ebx_disp8:
				GET_PCBYTE
				movsx	ebx, al
				add		ebx, [CPU_EBX]
				GET_PREFIX_DS

	align	32
sib_disp8:
				GET_PCBYTE		; sib
				mov		dl, al
				and		eax, 7		; base
				cmp		al, 4
				je		.base4
				cmp		al, 5
				je		near .base5

				mov		ebx, [CPU_REG + eax * 4]
				GET_PCBYTE		; disp8
				cbw
				cwde
				add		ebx, eax
				mov		cl, dl
				shr		cl, 6		; scale
				shr		dl, 3
				and		edx, 7		; index
				call	[sib_table + edx * 4]
				GET_PREFIX_DS

	.base4:		GET_PCBYTE		; disp8
				movsx	ebx, al
				add		ebx, [CPU_ESP]
				mov		cl, dl
				shr		cl, 6		; scale
				shr		dl, 3
				and		edx, 7		; index
				call	[sib_table + edx * 4]
				GET_PREFIX_SS

	.base5:		GET_PCBYTE		; disp8
				movsx	ebx, al
				add		ebx, [CPU_EBP]
				mov		cl, dl
				shr		cl, 6		; scale
				shr		dl, 3
				and		edx, 7		; index
				call	[sib_table + edx * 4]
				GET_PREFIX_SS

	align	32
ebp_disp8:
				GET_PCBYTE
				movsx	ebx, al
				add		ebx, [CPU_EBP]
				GET_PREFIX_SS

	align	32
esi_disp8:
				GET_PCBYTE
				movsx	ebx, al
				add		ebx, [CPU_ESI]
				GET_PREFIX_DS

	align	32
edi_disp8:
				GET_PCBYTE
				movsx	ebx, al
				add		ebx, [CPU_EDI]
				GET_PREFIX_DS

; mod: 10
	align	32
eax_disp32:
				GET_PCDWORD
				mov		ebx, eax
				add		ebx, [CPU_EAX]
				GET_PREFIX_DS

	align	32
ecx_disp32:
				GET_PCDWORD
				mov		ebx, eax
				add		ebx, [CPU_ECX]
				GET_PREFIX_DS

	align	32
edx_disp32:
				GET_PCDWORD
				mov		ebx, eax
				add		ebx, [CPU_EDX]
				GET_PREFIX_DS

	align	32
ebx_disp32:
				GET_PCDWORD
				mov		ebx, eax
				add		ebx, [CPU_EBX]
				GET_PREFIX_DS

	align	32
sib_disp32:
				GET_PCBYTE		; sib
				mov		dl, al
				and		eax, 7		; base
				cmp		al, 4
				je		.base4
				cmp		al, 5
				je		near .base5

				mov		ebx, [CPU_REG + eax * 4]
				GET_PCDWORD		; disp32
				add		ebx, eax
				mov		cl, dl
				shr		cl, 6		; scale
				shr		dl, 3
				and		edx, 7		; index
				call	[sib_table + edx * 4]
				GET_PREFIX_DS

	.base4:		GET_PCDWORD		; disp32
				mov		ebx, eax
				add		ebx, [CPU_ESP]
				mov		cl, dl
				shr		cl, 6		; scale
				shr		dl, 3
				and		edx, 7		; index
				call	[sib_table + edx * 4]
				GET_PREFIX_SS

	.base5:		GET_PCDWORD		; disp32
				mov		ebx, eax
				add		ebx, [CPU_EBP]
				mov		cl, dl
				shr		cl, 6		; scale
				shr		dl, 3
				and		edx, 7		; index
				call	[sib_table + edx * 4]
				GET_PREFIX_SS

	align	32
ebp_disp32:
				GET_PCDWORD
				mov		ebx, eax
				add		ebx, [CPU_EBP]
				GET_PREFIX_SS

	align	32
esi_disp32:
				GET_PCDWORD
				mov		ebx, eax
				add		ebx, [CPU_ESI]
				GET_PREFIX_DS

	align	32
edi_disp32:
				GET_PCDWORD
				mov		ebx, eax
				add		ebx, [CPU_EDI]
				GET_PREFIX_DS

section .data

	align	32, db 0
	global	resolve_table32
resolve_table32:
		dd		_eax,	eax_disp8,	eax_disp32,	_nop
		dd		_ecx,	ecx_disp8,	ecx_disp32,	_nop
		dd		_edx,	edx_disp8,	edx_disp32,	_nop
		dd		_ebx,	ebx_disp8,	ebx_disp32,	_nop
		dd		sib,	sib_disp8,	sib_disp32,	_nop
		dd		disp32,	ebp_disp8,	ebp_disp32,	_nop
		dd		_esi,	esi_disp8,	esi_disp32,	_nop
		dd		_edi,	edi_disp8,	edi_disp32,	_nop

section .text

; sib
; ebx: base(+disp)
; cl: scale
	align	32
sib_eax:
				mov		eax, [CPU_EAX]
				shl		eax, cl
				add		ebx, eax
				ret

	align	32
sib_ecx:
				mov		eax, [CPU_ECX]
				shl		eax, cl
				add		ebx, eax
				ret

	align	32
sib_edx:
				mov		eax, [CPU_EDX]
				shl		eax, cl
				add		ebx, eax
				ret

	align	32
sib_ebx:
				mov		eax, [CPU_EBX]
				shl		eax, cl
				add		ebx, eax
				ret

	align	32
sib_none:
				ret

	align	32
sib_ebp:
				mov		eax, [CPU_EBP]
				shl		eax, cl
				add		ebx, eax
				ret

	align	32
sib_esi:
				mov		eax, [CPU_ESI]
				shl		eax, cl
				add		ebx, eax
				ret

	align	32
sib_edi:
				mov		eax, [CPU_EDI]
				shl		eax, cl
				add		ebx, eax
				ret

section .data

	align	32, db 0
sib_table:
		dd		sib_eax
		dd		sib_ecx
		dd		sib_edx
		dd		sib_ebx
		dd		sib_none
		dd		sib_ebp
		dd		sib_esi
		dd		sib_edi

