
#define	NEKO

#ifdef KEROPI
#include	<windows.h>
#include	"fddfile.h"
#include	"fdd_d88.h"

#include	"../win32/common.h"
#include	"../win32/fileio.h"
#include	"fdc.h"

#define		FILEHDL		FILEH
#define		FILE_OPEN	File_Open
#define		FILE_READ	File_Read
#define		FILE_SEEK	File_Seek
#define		FILE_CLOSE	File_Close
#endif

#ifdef NEKO
#include	"compiler.h"

#include	"fddfile.h"
#include	"fdd_d88.h"
#include	"np2.h"
#include	"dosio.h"
#include	"iobridge.h"
#include	"dmac.h"
#include	"fdc.h"
#include	"trace.h"

#define		FILEHDL		FILEH
#define		FILE_OPEN	file_open
#define		FILE_READ	file_lread
#define		FILE_WRITE	file_lwrite
#define		FILE_SEEK	file_seek
#define		FILE_CLOSE	file_close
#endif

#define		D88BUFSIZE		0x4000
#define		D88TRACKMAX		10600

static	D88_HEADER	d88head[4];
static	D88_SECTOR	cursec;
static	BYTE		curdrv = 0xff;
static	WORD		curtrk = 0xffff;
static	BYTE		curwrite = 0;
static	DWORD		curfp = 0;
static	DWORD		cursize = 0;
static	BYTE		curtrkaccess = 0;
static	BYTE		curtype = 0;

static	BYTE		D88_BUF[D88BUFSIZE];

// ------------------------------------------------------------------------

static BOOL realfddtype(BYTE drv, BYTE type) {

	if (type != DISKTYPE_2DD) {
		return(type);
	}
	return(fddfile[drv].mode2d ^ 1);
}

static BOOL curdataflush(void) {

	FILEHDL	hdl;
	BOOL	ret = SUCCESS;

	if ((!curfp) || (!cursize) || (!curwrite)) {
		return(SUCCESS);
	}
	curwrite = 0;
	if ((hdl = FILE_OPEN(fddfile[curdrv].fname)) == (FILEHDL)-1) {
		return(FAILURE);
	}
	if ((FILE_SEEK(hdl, curfp, FSEEK_SET) != curfp) ||
		(FILE_WRITE(hdl, D88_BUF, cursize) != cursize)) {
		ret = FAILURE;
	}
	if (FILE_CLOSE(hdl)) {
		ret = FAILURE;
	}
	return(ret);
}


static void drvflush(BYTE drv) {

	if (curdrv == drv) {
		curdataflush();
		curdrv = 0xff;
		curtrk = 0xffff;
	}
}

static DWORD nexttrackp(D88_HEADER *head, DWORD fptr, DWORD last) {

	int		t;
	DWORD	ret;
	DWORD	tpos;

	ret = last;
	for (t=0; t<164; t++) {
		tpos = GETDWORD(head->trackp[t]);
		if ((tpos > fptr) && (tpos < ret)) {
			ret = tpos;
		}
	}
	return(ret);
}

static BOOL read_d88track(BYTE drv, BYTE track, BYTE type) {

	FILEHDL	hdl;

	curdataflush();
	curdrv = drv;
	curtrk = track;
	curtype = type;
	curwrite = 0;
	curtrkaccess = SUCCESS;

	if ((drv >= 4) || (track > 163) ||
		(type != (d88head[drv].fd_type >> 4))) {
		goto readd88_err;
	}
	curfp = GETDWORD(d88head[drv].trackp[track]);
	if (!curfp) {
		goto readd88_err;
	}
	if ((cursize = nexttrackp(&d88head[drv], curfp,
					GETDWORD(d88head[drv].fd_size)) - curfp) > D88BUFSIZE) {
		goto readd88_err;
	}
	if ((hdl = FILE_OPEN(fddfile[drv].fname)) == (FILEH)-1) {
		goto readd88_err;
	}
	if (FILE_SEEK(hdl, curfp, FSEEK_SET) != curfp) {
		FILE_CLOSE(hdl);
		goto readd88_err;
	}
	if (FILE_READ(hdl, D88_BUF, cursize) != cursize) {
		FILE_CLOSE(hdl);
		goto readd88_err;
	}
	if (FILE_CLOSE(hdl)) {
		goto readd88_err;
	}
	return(SUCCESS);

readd88_err:
	curfp = 0;
	cursize = 0;
	curtrkaccess = FAILURE;
	return(FAILURE);
}

static BOOL seek_d88(BYTE drv, BYTE track) {

	BYTE realfdd = realfddtype(drv, CTRL_FDMEDIA);

	if ((curdrv != drv) || (curtrk != track) || (curtype != realfdd)) {
		read_d88track(drv, track, realfdd);
	}
	return(curtrkaccess);
}

static D88_SECTOR *searchsector_d88(void) {

	BYTE	*p;
	BYTE	sec;
	WORD	pos = 0;

	p = D88_BUF;
	for (sec=0; sec<40; ) {
		if ((((D88_SECTOR *)p)->c == fdc.C) &&
			(((D88_SECTOR *)p)->h == fdc.H) &&
			(((D88_SECTOR *)p)->r == fdc.R) &&
			(((D88_SECTOR *)p)->n == fdc.N)) {
			return((D88_SECTOR *)p);
		}
		if (++sec >= GETWORD(((D88_SECTOR *)p)->sectors)) {
			break;
		}

		pos += GETWORD(((D88_SECTOR *)p)->size);
		pos += sizeof(D88_SECTOR);

		p += GETWORD(((D88_SECTOR *)p)->size);
		p += sizeof(D88_SECTOR);
	}
	return(NULL);
}

// ------------------------------------------------------------------------

BOOL fdd_set_d88(BYTE drv, LPSTR fname) {

	WORD	attr;
	FILEHDL	hdl;
	DWORD	rsize;

	fdd_eject_d88(drv);
	if ((attr = file_attr(fname)) & 0x18) {
		return(FAILURE);
	}
	if ((hdl = FILE_OPEN(fname)) == (FILEH)-1) {
		return(FAILURE);
	}
	rsize = FILE_READ(hdl, &d88head[drv], sizeof(D88_HEADER));
	FILE_CLOSE(hdl);
	if (rsize != sizeof(D88_HEADER)) {
		fdd_eject_d88(drv);
		return(FAILURE);
	}
	strcpy(fddfile[drv].fname, fname);
	fddfile[drv].type = DISKTYPE_D88;
	fddfile[drv].protect = FALSE;
	if ((attr & 1) || (d88head[drv].protect & 0x10)) {
		fddfile[drv].protect = TRUE;
	}
	return(SUCCESS);
}

BOOL fdd_eject_d88(BYTE drv) {

	drvflush(drv);
	ZeroMemory(&d88head[drv], sizeof(D88_HEADER));
	fddfile[drv].fname[0] = '\0';
	fddfile[drv].type = DISKTYPE_NOTREADY;
	return(SUCCESS);
}


BOOL fdd_diskaccess_d88(void) {

	if (realfddtype(fdc.us, CTRL_FDMEDIA) != (d88head[fdc.us].fd_type >> 4)) {
		return(FAILURE);
	}
	return(SUCCESS);
}

BOOL fdd_seek_d88(void) {

	if (fdc.ncn >= 82) {
		return(FAILURE);
	}
	return(seek_d88(fdc.us, (fdc.ncn << 1) + fdc.hd));
}

BOOL fdd_seeksector_d88(void) {

	if (fdc.treg[fdc.us] >= 82) {
		return(FAILURE);
	}
	if (seek_d88(fdc.us, (fdc.treg[fdc.us] << 1) + fdc.hd)) {
		return(FAILURE);
	}
	if (!searchsector_d88()) {
		return(FAILURE);
	}
	return(SUCCESS);
}

BOOL fdd_read_d88(void) {

	D88_SECTOR	*p;
	WORD		size;

	fddlasterror = 0x00;
	if (fdc.treg[fdc.us] >= 82) {
		fddlasterror = 0xe0;									// ver0.28
		return(FAILURE);
	}
	if (seek_d88(fdc.us, (fdc.treg[fdc.us] << 1) + fdc.hd)) {
		fddlasterror = 0xe0;									// ver0.28
		return(FAILURE);
	}
	p = searchsector_d88();
	if (!p) {
		fddlasterror = 0xc0;									// ver0.28
		return(FAILURE);
	}
	if (fdc.N < 8) {
		size = 128 << fdc.N;
	}
	else {
		size = 128 << 8;
	}
	fdc.bufcnt = size;
	ZeroMemory(fdc.buf, size);
	if (size > GETWORD(p->size)) {
		size = GETWORD(p->size);
	}
	if (size) {
		memcpy(fdc.buf, p+1, size);
	}
	fddlasterror = p->stat;
	return(SUCCESS);
}

BOOL fdd_write_d88(void) {

	D88_SECTOR	*p;
	WORD		size;

	fddlasterror = 0x00;										// ver0.28
	if (fdc.treg[fdc.us] >= 82) {
		fddlasterror = 0xe0;									// ver0.28
		return(FAILURE);
	}
	if (seek_d88(fdc.us, (fdc.treg[fdc.us] << 1) + fdc.hd)) {
		fddlasterror = 0xe0;									// ver0.28
		return(FAILURE);
	}
	p = searchsector_d88();
	if (!p) {
		fddlasterror = 0xc0;									// ver0.28
		return(FAILURE);
	}
	if (fdc.N < 8) {
		size = 128 << fdc.N;
	}
	else {
		size = 128 << 8;
	}
	if (size > GETWORD(p->size)) {
		size = GETWORD(p->size);
	}
	if (size) {
		memcpy(p+1, fdc.buf, size);
		curwrite = TRUE;
	}
	fddlasterror = 0x00;										// ver0.28
	return(SUCCESS);
}

BOOL fdd_readid_d88(void) {

	BYTE	*p;
	BYTE	sec;

	fddlasterror = 0x00;										// ver0.28
	if (fdc.treg[fdc.us] >= 82) {
		fddlasterror = 0xe0;									// ver0.28
		return(FAILURE);
	}
	if (seek_d88(fdc.us, (fdc.treg[fdc.us] << 1) + fdc.hd)) {
		fddlasterror = 0xe0;									// ver0.28
		return(FAILURE);
	}
	p = D88_BUF;
	for (sec=0; sec<40; ) {
		if (sec == fdc.crcn) {
			fdc.C = ((D88_SECTOR *)p)->c;
			fdc.H = ((D88_SECTOR *)p)->h;
			fdc.R = ((D88_SECTOR *)p)->r;
			fdc.N = ((D88_SECTOR *)p)->n;
			fdc.crcn++;
#if 1
			if (fdc.crcn >= GETWORD(((D88_SECTOR *)p)->sectors)) {
				fdc.crcn = 0;
			}
#endif
			fddlasterror = 0x00;								// ver0.28
			return(SUCCESS);
		}
		if (++sec >= GETWORD(((D88_SECTOR *)p)->sectors)) {
			break;
		}
		p += GETWORD(((D88_SECTOR *)p)->size);
		p += sizeof(D88_SECTOR);
	}
	fdc.crcn = 0xff;
	fddlasterror = 0xa0;										// ver0.28
	return(FAILURE);
}

// --------------------------------------------------------------------------

static BOOL formating = FALSE;
static BYTE formatsec = 0;
static BYTE formatwrt = 0;
static WORD formatpos = 0;

static int fileappend(FILEH hdl, D88_HEADER *head,
									long ptr, long last, long apsize) {

	long	length;
	WORD	size;
	WORD	rsize;
	int		t;
	long	tpos;
	BYTE	tmp[0x4000];

	if (apsize <= 0) {
		return(0);
	}
	if ((length = last - ptr) <= 0) {			// 񤭴ɬפʤ
		return(0);
	}
	file_seek(hdl, 0, FSEEK_END);
	file_zeroclr(hdl, apsize);
	while(length) {
		if (length >= sizeof(tmp)) {
			size = sizeof(tmp);
		}
		else {
			size = (WORD)length;
		}
		length -= (long)size;
		file_seek(hdl, ptr+length, 0);
		rsize = file_read(hdl, tmp, size);
		file_seek(hdl, ptr+length+apsize, 0);
		file_write(hdl, tmp, rsize);
	}

	for (t=0; t<164; t++) {
		tpos = GETDWORD(head->trackp[t]);
		if ((tpos) && (tpos >= ptr)) {
			tpos += apsize;
			SETDWORD(head->trackp[t], tpos);
		}
	}
	return(0);
}


static void endoftrack(WORD fmtsize, BYTE sectors) {

	FILEH		hdl;
	int			i;
	WORD		trk;
	D88_HEADER	*head;
	long		fpointer;
	long		endpointer;
	long		lastpointer;
	long		trksize;
	int			ptr;
	long		apsize;

	head = &d88head[fdc.us];
	trk = (fdc.treg[fdc.us] << 1) + fdc.hd;

	ptr = 0;
	for (i=0; i<(int)sectors; i++) {
		SETWORD(((D88_SECTOR *)(&D88_BUF[ptr]))->sectors, sectors);
		ptr += GETWORD(((D88_SECTOR *)(&D88_BUF[ptr]))->size)
												+ sizeof(D88_SECTOR);
	}

	if ((hdl = FILE_OPEN(fddfile[fdc.us].fname)) == (FILEH)-1) {
		return;
	}
	lastpointer = file_seek(hdl, 0, 2);
	fpointer = GETDWORD(head->trackp[trk]);
	if (!fpointer) {								// ȥå
		for (i=trk; i>=0; i--) {
			fpointer = GETDWORD(head->trackp[i]);
			if (fpointer) {
				break;
			}
		}
		if (fpointer) {								// ҥåȤ
			fpointer = nexttrackp(head, fpointer, lastpointer);
		}
		else {
			fpointer = sizeof(D88_HEADER);
		}
		endpointer = fpointer;
	}
	else {										// ȥåǡϴˤ
		endpointer = nexttrackp(head, fpointer, lastpointer);
	}
	trksize = endpointer - fpointer;
	if ((apsize = (long)fmtsize - trksize) > 0) {
								// 񤭹ǡΤۡ礭
		fileappend(hdl, head, endpointer, lastpointer, apsize);
		{
			long tmp;
			tmp = GETDWORD(head->fd_size);
			tmp += apsize;
			SETDWORD(head->fd_size, tmp);
		}
	}
	SETDWORD(head->trackp[trk], fpointer);
	file_seek(hdl, fpointer, 0);
	file_write(hdl, D88_BUF, fmtsize);
	file_seek(hdl, 0, 0);
	file_write(hdl, head, sizeof(D88_HEADER));
	file_close(hdl);
}


BOOL fdd_formatinit_d88(void) {

	if (fdc.treg[fdc.us] < 82) {
		formating = TRUE;
		formatsec = 0;
		formatpos = 0;
		formatwrt = 0;
		curdataflush();
		curdrv = 0xff;
		return(SUCCESS);
	}
	return(FAILURE);
}

	// todo եޥåȤȤ ǥڤΤƤȤ
BOOL fdd_formating_d88(BYTE *ID) {

	WORD	size;

	if (!formating) {
		return(FAILURE);
	}
	if (fdc.N < 8) {
		size = 128 << fdc.N;
	}
	else {
		size = 128 << 8;
	}
	if ((formatpos + sizeof(D88_SECTOR) + size) < D88TRACKMAX) {
		ZeroMemory(D88_BUF + formatpos, sizeof(D88_SECTOR));
		CopyMemory(D88_BUF + formatpos, ID, 4);
		SETWORD(((D88_SECTOR *)(&D88_BUF[formatpos]))->size, size);
		formatpos += sizeof(D88_SECTOR);
		memset(D88_BUF + formatpos, fdc.d, size);
		formatpos += size;
		formatwrt++;
	}
	formatsec++;
	TRACE_("format sec", formatsec);
	TRACE_("format wrt", formatwrt);
	TRACE_("format max", fdc.sc);
	TRACE_("format pos", formatpos);
	if (formatsec >= fdc.sc) {
		endoftrack(formatpos, formatwrt);
		formating = FALSE;
	}
	return(SUCCESS);
}

BOOL fdd_isformating_d88(void) {

	return(formating);
}

