/*	$Id: xdraw.h,v 1.7 2003/06/05 18:11:23 nonaka Exp $	*/

/*
 * Copyright (c) 2002-2003 NONAKA Kimihiro
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef	__NP2_XDRAW_H__
#define	__NP2_XDRAW_H__

#define	SURFACE_WIDTH		640
#define	SURFACE_HEIGHT		480
#define	SCRN_BUFSIZE		0x4b000

#define	START_PALORG		0x0a
#define	START_PAL		0x10

#define	SCMD_SETWINDOWED	0x01
#define	SCMD_SETFULLSCREEN	0x02
#define	SCMD_SET256		0x04
#define	SCMD_SET65536		0x08
#define	SCMD_XORWINDOWED	0x10
#define	SCMD_XORFULLSCREEN	0x10

#define	SCMD_SETNORMAL		0x40
#define	SCMD_SETTURN		0x80
#define	SCMD_SETLEFT		(SCMD_SETTURN | 0x00)
#define	SCMD_SETRIGHT		(SCMD_SETTURN | 0x40)

#define	SCMD_COLOR8		3
#define	SCMD_COLOR16		2
#define	SCMD_COLOR24		1
#define	SCMD_COLOR32		0

#define	SCMD_COLORMASK		0x03
#define	SCMD_FULLSCRN		0x04
#define	SCMD_WINDOWED		0x08
#define	SCMD_USEPAL		0x10
#define	SCMD_NONPAL		0x20

#define	SCMD_WINDOW8		(SCMD_WINDOWED | SCMD_COLOR8 | SCMD_USEPAL)
#define	SCMD_WINDOW16		(SCMD_WINDOWED | SCMD_COLOR16 | SCMD_NONPAL)
#define	SCMD_WINDOW24		(SCMD_WINDOWED | SCMD_COLOR24 | SCMD_NONPAL)
#define	SCMD_WINDOW32		(SCMD_WINDOWED | SCMD_COLOR32 | SCMD_NONPAL)

#define	SCMD_FSCREEN8		(SCMD_FULLSCRN | SCMD_COLOR8 | SCMD_USEPAL)
#define	SCMD_FSCREEN16		(SCMD_FULLSCRN | SCMD_COLOR16 | SCMD_NONPAL)
#define	SCMD_FSCREEN24		(SCMD_FULLSCRN | SCMD_COLOR24 | SCMD_NONPAL)
#define	SCMD_FSCREEN32		(SCMD_FULLSCRN | SCMD_COLOR32 | SCMD_NONPAL)

typedef struct {
	WORD left;
	WORD top;
	WORD right;
	WORD bottom;
} rect_t;

typedef struct {
	DWORD sx;
	DWORD sy;

	DWORD x1;
	DWORD w;
	DWORD x2;

	DWORD y1;
	DWORD h;
	DWORD y2;
} NP2WIN_T;

extern BYTE setscmd;
extern BYTE SCREENMODE;

extern int allflash;
extern int displaymodel;
extern int displaymoder;
extern int palchanged;
extern int nordisplay;

extern NP2RECT realdisp; 
extern NP2WIN_T vir;
extern XYSIZE minisize;
extern XYSIZE minisize2;

void draws_init(void);
int xdraws_setup(GtkWidget *);
void xdraws_term(GtkWidget *);

BYTE xdraws_draws(GtkWidget *, int);
void xdraws_drawall(GtkWidget *);

void xdraws_redraw(GtkWidget *);
BYTE xdraws_setdisplaymode(void);
void xdraws_windowstats(GtkWidget *);
BYTE xdraws_setscreenmode(BYTE mode);

void xdraws_adjustleft(void);

void fillrenewalline(BYTE);

#endif	/* __NP2_XDRAW_H__ */
