#include	"compiler.h"

#include	"i286.h"
#include	"iobridge.h"
#include	"pc_core.h"
#include	"nevent.h"
#include	"artic.h"


	ARTIC_T		artic;

void artic_init(void) {

	ZeroMemory(&artic, sizeof(artic));
}

void artic_callback(void) {

	long	mul;
	long	leng;

	mul = pc.multiple;
	if (pc.baseclock != PCBASECLOCK20) {
		mul *= 16;
	}
	else {
		mul *= 13;
	}
	leng = nevent.clock + nevent.baseclock - nevent.remainclock;
	leng *= 2;
	leng -= artic.lastclk2;
	if (leng > 0) {
		leng /= mul;
		artic.counter += leng;
		artic.lastclk2 += leng * mul;
	}
}

static DWORD getcnt(void) {

	long	mul;
	long	leng;

	mul = pc.multiple;
	if (pc.baseclock != PCBASECLOCK20) {
		mul *= 16;
	}
	else {
		mul *= 13;
	}
	leng = nevent.clock + nevent.baseclock - nevent.remainclock;
	leng *= 2;
	leng -= artic.lastclk2;
	if (leng > 0) {
		leng /= mul;
		return(artic.counter + leng);
	}
	return(artic.counter);
}

I286_INB artic_r(WORD port) {

	DWORD	cnt;

	cnt = getcnt();
	switch(port & 3) {
		case 0:
			return((BYTE)cnt);
		case 3:
			return((BYTE)(cnt >> 16));
	}
	return((BYTE)(cnt >> 8));
}


I286_INW artic_r_w(WORD port) {

	DWORD	cnt;

	cnt = getcnt();
	if (port & 2) {
		cnt >>= 8;
	}
	return((WORD)cnt);
}

