#include	"compiler.h"

#include	"iobridge.h"
#include	"memory.h"
#include	"dosio.h"
#include	"cgrom.h"
#include	"crtc.h"
#include	"font.h"


CGROM_TABLE		cgrom;

#ifdef __cplusplus
extern "C" {
#endif
CGWINDOW_TABLE	cgwindow;
#ifdef __cplusplus
}
#endif

static void cgwindowset(void) {

	cgwindow.low = 0x7fff0;
	cgwindow.writable &= ~1;
	if (grcg.chip >= 2) {
		if (!(cgrom.code.w & 0xff00)) {
			cgwindow.high = 0x80000 + (cgrom.code.w << 4);
		}
		else {
			BYTE code = cgrom.code.w & 0x007f;
			cgwindow.high = (cgrom.code.w & 0x7f7f) << 4;
			if ((code >= 0x56) && (code < 0x58)) {
				cgwindow.writable |= 1;
				cgwindow.high += cgrom.lr;
			}
			else if (((code >= 0x0c) && (code < 0x10)) ||
				((code >= 0x58) && (code < 0x60))) {
				cgwindow.high += cgrom.lr;
			}
			else if ((code < 0x08) || (code >= 0x10)) {
				cgwindow.low = cgwindow.high;
				cgwindow.high += 0x800;
			}
		}
	}
	else {
		cgwindow.high = cgwindow.low;
	}
}

// ---------------------------------------------------------------------------

void cgrom_init(void) {

	ZeroMemory(&cgrom, sizeof(cgrom));
	cgwindow.low = 0x7fff0;
	cgwindow.high = 0x7fff0;
	cgwindow.writable = 0;
}


I286_OUT cgrom_w(WORD port, BYTE value) {

	switch(port & 0x0f) {
		case 1:						// write charactor code low
			XWORD_BYTE(cgrom.code, X_HIGH) = value;
			cgwindowset();
			break;
		case 3:						// write charactor code high
			XWORD_BYTE(cgrom.code, X_LOW) = value;
			cgwindowset();
			break;
		case 5:						// write charactor line
			cgrom.line = value & 0x0f;
			cgrom.lr = ((~value) & 0x20) << 6;
			cgwindowset();
			break;
		case 9:						// CG write pattern
			if ((cgrom.code.w & 0x007e) == 0x0056) {
				font[((cgrom.code.w & 0x7f7f) << 4) + cgrom.lr
												+ cgrom.line] = value;
				cgwindow.writable |= 0x80;
			}
			break;
	}
}

I286_INB cgrom_r(WORD port) {

	if ((port & 0x0f) == 0x09) {
		if (cgrom.code.w & 0xff00) {						// kanji
			return(font[((cgrom.code.w & 0x7f7f) << 4) + cgrom.lr
												+ cgrom.line]);
		}
		else {												// ascii?
			return(font[0x80000 + (cgrom.code.w << 4) + cgrom.line]);
		}
	}
	return(0xff);
}
