#include	"compiler.h"

#include	"i286.h"
#include	"iobridge.h"
#include	"memory.h"
#include	"extmem.h"
#include	"cpuio.h"

#ifdef __cplusplus
extern "C" {
#endif
EXTMEM_TABLE	extmem;
#ifdef __cplusplus
}
#endif

static MEM_HDL	extmemmng_ptr = NULL;
static DWORD	extmemmng_size = 0;

void extmemmng_clear(void) {

	if (extmemmng_ptr) {
		np2os_free(extmemmng_ptr);
		extmemmng_ptr = NULL;
		extmemmng_size = 0;
	}
}

BOOL extmemmng_realloc(DWORD megabytes) {

	megabytes <<= 20;
	if (megabytes != extmemmng_size) {
		extmemmng_clear();
		extmemmng_ptr = np2os_malloc(megabytes);
		if (extmemmng_ptr == NULL) {
			return(FAILURE);
		}
		extmemmng_size = megabytes;
	}
	return(SUCCESS);
}

// --------------------------------------------------------------------------

BOOL extmem_init(BYTE usemem) {

	DWORD	i;

	if (usemem > 13) {											// ver0.28
		usemem = 13;
	}
	extmem.adrsmask = 0x0fffff;
	extmem.target = 0;
	extmem.maxmem = 0;
	for (i=0; i<4; i++) {
		extmem.pageptr[i] = mem + 0xc0000 + (i << 14);			// ver0.28
	}
	if (extmemmng_realloc(usemem)) {
		return(FAILURE);
	}
	extmem.maxmem = (DWORD)usemem + 1;

#if defined(CPU386)
	init_cpumem(usemem);
#endif

	return(SUCCESS);
}

I286_OUT emm_w(WORD port, BYTE value) {

	DWORD	pos;

	if (!(CPUTYPE & CPUTYPE_V30)) {
		port &= 0x0f;
		pos = port >> 1;
		switch(port) {
			case 1:
			case 3:
			case 5:
			case 7:
				if (!extmem.target) {							// ver0.28
					extmem.pageptr[pos] = mem + 0xc0000 + (pos << 14);
				}
				else if (extmem.target < extmem.maxmem) {		// ver0.28
					extmem.pageptr[pos] = (BYTE *)extmemmng_ptr +
										((extmem.target-1) << 20) +
										((DWORD)(value & 0xfc) << 12);
				}
				break;
			case 9:
				extmem.target = value & 0x0f;
				break;
		}
	}
}


I286_INB emm_r(WORD port) {

	if ((!(CPUTYPE & CPUTYPE_V30)) && ((port & 0x0f) == 0x09)) {
		if ((extmem.target < extmem.maxmem)) {
			return(0);
		}
	}
	return(0xff);
}

