enum {
	FDCEVENT_NEUTRAL,
	FDCEVENT_CMDRECV,
	FDCEVENT_DATSEND,
	FDCEVENT_BUFRECV,
	FDCEVENT_BUFSEND,
	FDCEVENT_BUFSEND2,
	FDCEVENT_NEXTDATA,
	FDCEVENT_BUSY
};

#define		LENGTH_GAP0		80
#define		LENGTH_SYNC		12
#define		LENGTH_IM		4
#define		LENGTH_GAP1		50
#define		LENGTH_SYNC		12
#define		LENGTH_IAM		4
#define		LENGTH_ID		4
#define		LENGTH_CRC		2
#define		LENGTH_GAP2		22
#define		LENGTH_DAM		4

#define		LENGTH_PRIAMP (LENGTH_GAP0+LENGTH_SYNC+LENGTH_IM+LENGTH_GAP1)

// real sector size = LENGTH_SECTOR + (128 << n) + gap3
#define		LENGTH_SECTOR (LENGTH_SYNC+LENGTH_IAM+LENGTH_ID+LENGTH_CRC+LENGTH_GAP2+LENGTH_SYNC+LENGTH_DAM+LENGTH_CRC)

#define		LENGTH_TRACK	10600			// normal: 	(+-2%)


#define		FDCRLT_NR		0x000008
#define		FDCRLT_EC		0x000010
#define		FDCRLT_SE		0x000020
#define		FDCRLT_IC0		0x000040
#define		FDCRLT_IC1		0x000080

#define		FDCRLT_MA		0x000100
#define		FDCRLT_NW		0x000200
#define		FDCRLT_ND		0x000400
#define		FDCRLT_OR		0x001000
#define		FDCRLT_DE		0x002000
#define		FDCRLT_EN		0x008000

#define		FDCRLT_MD		0x010000
#define		FDCRLT_BC		0x020000
#define		FDCRLT_SN		0x040000
#define		FDCRLT_SH		0x080000
#define		FDCRLT_NC		0x100000
#define		FDCRLT_DD		0x200000
#define		FDCRLT_CM		0x400000

#define		FDCRLT_EXT		0x80000000

#define		FDCSTAT_CB		0x10
#define		FDCSTAT_NDM		0x20
#define		FDCSTAT_DIO		0x40
#define		FDCSTAT_RQM		0x80

typedef struct {
	BYTE	us, hd;
	BYTE	mt, mf, sk;
	BYTE	eot, gpl, dtl;
	BYTE	C, H, R, N;
	BYTE	srt, hut, hlt, nd;
	BYTE	stp, ncn, sc, d;

	BYTE	status;
	BYTE	intreq;
	BYTE	lastdata;
	BYTE	tc;

	DWORD	stat[4];
	BYTE	treg[4];

	int		event;
	int		cmdp;
	int		cmdcnt;
	int		datp;
	int		datcnt;
	int		bufp;
	int		bufcnt;

	BYTE	cmd;
	BYTE	cmds[15];
	BYTE	data[16];
	BYTE	buf[0x8000];

	BYTE	ctrlfd;
	BYTE	crcn;

	BYTE	ctrlreg;
	BYTE	busy;
} FDC_TABLE;

extern	FDC_TABLE		fdc;


// WinX68k
// #define	CTRL_FDMEDIA	DISKTYPE_2HD

#define	CTRL_FDMEDIA	fdc.ctrlfd

void fdc_init(void);
void fdc_interrupt(void);

I286_OUT fdc_w(WORD port, BYTE value);
I286_INB fdc_r(WORD port);

I286_OUT fdc2dd_w(WORD port, BYTE value);
I286_INB fdc2dd_r(WORD port);

DMAC_OUT fdc_DataRegWrite(BYTE data);
DMAC_IN fdc_DataRegRead(void);
DMAC_EXT fdc_dmafunc(BYTE func);

void fdcsend_error7(void);
void fdcsend_success7(void);
