#define	GDCCMD_MAX	32

typedef struct {
	BYTE	para[256];
	WORD	fifo[GDCCMD_MAX];
	WORD	cnt;
	BYTE	ptr;
	BYTE	rcv;
	BYTE	snd;
	BYTE	reserved;
} GDCDATA_TABLE;

typedef struct {
	GDCDATA_TABLE	m;
	GDCDATA_TABLE	s;
	BYTE			mode1;
	BYTE			mode2;
	BYTE			vsync;
	BYTE			vsyncint;
	int				analog;
	int				palnum;
	BYTE			degpal[4];
	PALETTE_TABLE	anapal[16];
	BYTE			clock;
	BYTE			display;
	BYTE			bitac;
	BYTE			m_drawing;
	BYTE			s_drawing;
	BYTE			reserved[3];
} GDC_TABLE;

typedef struct {
	BYTE	access;
	BYTE	disp;
	BYTE	textdisp;
	BYTE	msw_accessable;
	BYTE	grphdisp;
	BYTE	palchange;
	BYTE	mode2;
} GDCS_TABLE;

extern	GDC_TABLE	gdc;

#ifdef __cplusplus
extern "C" {
#endif
extern	GDCS_TABLE	gdcs;
#ifdef __cplusplus
}
#endif

#define	GDC_BLUE		((int)(&(((PALETTE_TABLE *)NULL)->p.b)))
#define	GDC_RED			((int)(&(((PALETTE_TABLE *)NULL)->p.r)))
#define	GDC_GREEN		((int)(&(((PALETTE_TABLE *)NULL)->p.g)))

#define	GDC_DEGBBIT		0x01
#define	GDC_DEGRBIT		0x02
#define	GDC_DEGGBIT		0x04

#define	GDCSCRN_ENABLE		0x80
#define	GDCSCRN_EXT			0x40
// #define	GDCSCRN_EXTENDDRAW	0x10
#define	GDCSCRN_ALLDRAW		0x04
#define	GDCSCRN_REDRAW		0x01
#define	GDCSCRN_ALLDRAW2	0x0c
#define	GDCSCRN_REDRAW2		0x03
#define	GDCSCRN_MAKE		(GDCSCRN_ALLDRAW | GDCSCRN_REDRAW)

void gdc_init(void);

I286_OUT gdc_master_w(WORD port, BYTE value);
I286_INB gdc_master_r(WORD port);
I286_OUT gdc_slave_w(WORD port, BYTE value);
I286_INB gdc_slave_r(WORD port);

void gdc_work(int id);
void gdc_reset(GDCDATA_TABLE *item);
void gdc_paletteinit(void);

void gdc_setdegitalpal(int color, BYTE value);
void gdc_setanalogpal(int color, int rgb, BYTE value);
void gdc_setdegpalpack(int color, BYTE value);

void gdc_restorekacmode(void);

#define	GDCWORK_MASTER		0
#define	GDCWORK_SLAVE		1
