#include	"compiler.h"

#include	<math.h>
#include	"np2pc98.h"
#include	"pc_core.h"
#include	"iobridge.h"
#include	"gdc.h"
#include	"gdc_sub.h"
#include	"crtc.h"
#include	"memory.h"
#include	"nevent.h"
#include	"trace.h"


static	BYTE	*gdcsubp;
static	BYTE	updatebit;
static	WORD	pattern;
static	DWORD	operate;
static	DWORD	dots;				// Ǥäɥåȿ

#define	RT_MULBIT		15
#define	RT_TABLEBIT		12
#define	RT_TABLEMAX		(1 << RT_TABLEBIT)

static	DWORD	gdc_rt[RT_TABLEMAX+1];

void gdcsub_init(void) {

	int		i;

	for (i=0; i<=RT_TABLEMAX; i++) {
		gdc_rt[i] = (WORD)((double)(1 << RT_MULBIT) *
				(1 - sqrt(1 - pow((0.70710678118654 * i) / RT_TABLEMAX, 2))));
	}
}


static DWORD vramp[4] = {VRAM_E, VRAM_B, VRAM_R, VRAM_G};

static BOOL gdcsub_prepart(DWORD csrw, WORD pat, BYTE ope, WORD *x, WORD *y) {

	dots = 0;
	if (!gdcs.access) {
		gdcsubp = mem;
		updatebit = 1;
	}
	else {
		gdcsubp = mem + VRAM_STEP;
		updatebit = 2;
	}
	gdcs.grphdisp |= updatebit;
	if (!(grcg.gdcwithgrcg & 0x8)) {						// ver0.27
		gdcsubp += vramp[(csrw >> 14) & 3];
	}
	*y = (WORD)((csrw & 0x3fff) / 40);
	*x = (WORD)((((csrw & 0x3fff) % 40) << 4) + ((csrw >> 20) & 0x0f));
	pattern = pat;
	operate = ope & 3;
	return(SUCCESS);
}



// ---------------------------------------------------------------------- ASM
#ifdef NP2_GDCOPE_ASM

LABEL static void gdc_REPLACE(void) {

		__asm {
				mov		al, updatebit
				or		[ebx], al
				rol		pattern, 1
				jc		opeset
				btr		word ptr [edx], cx
				pop		ecx
				pop		ebx
				ret
		opeset:	bts		word ptr [edx], cx
				pop		ecx
				pop		ebx
				ret
		}
}

LABEL static void gdc_COMPLEMENT(void) {

		__asm {
				rol		pattern, 1
				jnc		nooperate
				btc		word ptr [edx], cx
				mov		al, updatebit
				or		[ebx], al
		nooperate:
				pop		ecx
				pop		ebx
				ret
		}
}

LABEL static void gdc_CLEAR(void) {

		__asm {
				rol		pattern, 1
				jnc		nooperate
				btr		word ptr [edx], cx
				mov		al, updatebit
				or		[ebx], al
		nooperate:
				pop		ecx
				pop		ebx
				ret
		}
}

LABEL static void gdc_SET(void) {

		__asm {
				rol		pattern, 1
				jnc		nooperate
				bts		word ptr [edx], cx
				mov		al, updatebit
				or		[ebx], al
		nooperate:
				pop		ecx
				pop		ebx
				ret
		}
}

LABEL static void gdc_nop(void) {

		__asm {
				rol		pattern, 1
				pop		ecx
				pop		ebx
				ret
		}
}

LABEL static void gdc_tdw(void) {

		__asm {
				rol		pattern, 1
				jnc		nooperate
				mov		al, updatebit
				or		[ebx], al
				mov		al, byte ptr (grcg.tile[0*2])	// ver0.27
				and		[edx + VRAM_B], al				// GRCG쥸 WORD
				mov		al, byte ptr (grcg.tile[1*2])	// ˤƤ˺Ƥ
				and		[edx + VRAM_R], al
				mov		al, byte ptr (grcg.tile[2*2])
				and		[edx + VRAM_G], al
				mov		al, byte ptr (grcg.tile[3*2])
				and		[edx + VRAM_E], al
		nooperate:
				pop		ecx
				pop		ebx
				ret
		}
}

LABEL static void gdc_rmw(void) {

		__asm {
				rol		pattern, 1
				jnc		nooperate
				mov		al, updatebit
				or		[ebx], al
				mov		al, 1
				shl		al, cl
				mov		bl, al
				mov		bh, al
				mov		cx, bx
				not		al
				and		bl, byte ptr (grcg.tile[0*2])			// ver0.27
				and		bh, byte ptr (grcg.tile[1*2])
				and		cl, byte ptr (grcg.tile[2*2])
				and		ch, byte ptr (grcg.tile[3*2])
				and		[edx + VRAM_B], al
				or		[edx + VRAM_B], bl
				and		[edx + VRAM_R], al
				or		[edx + VRAM_R], bh
				and		[edx + VRAM_G], al
				or		[edx + VRAM_G], cl
				and		[edx + VRAM_E], al
				or		[edx + VRAM_E], ch
		nooperate:
				pop		ecx
				pop		ebx
				ret
		}
}

						//  rolateȤʤΤʤ¤
static void (*gdcsubope[])(void) = {
		gdc_REPLACE,	gdc_COMPLEMENT,		gdc_CLEAR,		gdc_SET,
		gdc_REPLACE,	gdc_COMPLEMENT,		gdc_CLEAR,		gdc_SET,
		gdc_tdw,		gdc_tdw,			gdc_nop,		gdc_tdw,
		gdc_rmw,		gdc_rmw,			gdc_nop,		gdc_rmw};

LABEL static void FASTCALL gdcsub_pset(WORD x, WORD y) {

		__asm {
				inc		dots					//	dec nevent.remainclock
				cmp		dx, 409
				ja		outofscreen
				jne		screenxcheck
				cmp		cx, 384
				jae		outofscreen
		screenxcheck:
				cmp		cx, 640
				jae		outofscreen
				push	ebx
				push	ecx
				imul	ax, dx, 80
				xor		edx, edx
				mov		dx, cx
				shr		dx, 3
				add		dx, ax
				mov		eax, operate					// 000706
				and		eax, 3
				add		eax, grcg.gdcwithgrcg
				lea		ebx, vramupdate[edx]
				add		edx, gdcsubp
				not		cx
				and		cx, 7
				jmp		gdcsubope[eax*4]
		outofscreen:
				rol		pattern, 1
				ret
		}
}

#else
// ---------------------------------------------------------------------- C

static void GDCOPE_CALL gdc_nop(DWORD p, WORD b) {

	pattern = (pattern << 1) | (pattern >> 15);
}

static void GDCOPE_CALL gdc_REPLACE(DWORD p, WORD b) {

	vramupdate[p] |= updatebit;
	if (pattern & 0x8000) {
		pattern <<= 1;
		pattern++;
		gdcsubp[p] |= (0x80 >> b);
	}
	else {
		pattern <<= 1;
		gdcsubp[p] &= ~(0x80 >> b);
	}
}

static void GDCOPE_CALL gdc_COMPLEMENT(DWORD p, WORD b) {

	if (pattern & 0x8000) {
		pattern <<= 1;
		pattern++;
		gdcsubp[p] ^= (0x80 >> b);
		vramupdate[p] |= updatebit;
	}
	else {
		pattern <<= 1;
	}
}

static void GDCOPE_CALL gdc_CLEAR(DWORD p, WORD b) {

	if (pattern & 0x8000) {
		pattern <<= 1;
		pattern++;
		gdcsubp[p] &= ~(0x80 >> b);
		vramupdate[p] |= updatebit;
	}
	else {
		pattern <<= 1;
	}
}

static void GDCOPE_CALL gdc_SET(DWORD p, WORD b) {

	if (pattern & 0x8000) {
		pattern <<= 1;
		pattern++;
		gdcsubp[p] |= (0x80 >> b);
		vramupdate[p] |= updatebit;
	}
	else {
		pattern <<= 1;
	}
}

static void GDCOPE_CALL gdc_tdw(DWORD p, WORD b) {

	if (pattern & 0x8000) {
		pattern <<= 1;
		pattern++;
		vramupdate[p] |= updatebit;
									//  GDC_SUB andˤʤäƤ衩
		gdcsubp[p + VRAM_B] = grcg.tile[0].b[0];
		gdcsubp[p + VRAM_R] = grcg.tile[1].b[0];
		gdcsubp[p + VRAM_G] = grcg.tile[2].b[0];
		gdcsubp[p + VRAM_E] = grcg.tile[3].b[0];
	}
	else {
		pattern <<= 1;
	}
}

static void GDCOPE_CALL gdc_rmw(DWORD p, WORD b) {

	if (pattern & 0x8000) {
		BYTE bit, mask;
		pattern <<= 1;
		pattern++;
		vramupdate[p] |= updatebit;

		bit = (0x80 >> b);
		mask = ~bit;
		gdcsubp[p + VRAM_B] &= mask;
		gdcsubp[p + VRAM_B] |= bit & grcg.tile[0].b[0];
		gdcsubp[p + VRAM_R] &= mask;
		gdcsubp[p + VRAM_R] |= bit & grcg.tile[1].b[0];
		gdcsubp[p + VRAM_G] &= mask;
		gdcsubp[p + VRAM_G] |= bit & grcg.tile[2].b[0];
		gdcsubp[p + VRAM_E] &= mask;
		gdcsubp[p + VRAM_E] |= bit & grcg.tile[3].b[0];
	}
	else {
		pattern <<= 1;
	}
}


static void (GDCOPE_CALL * gdcsubope[])(DWORD p, WORD b) = {
		gdc_REPLACE,	gdc_COMPLEMENT,		gdc_CLEAR,		gdc_SET,
		gdc_REPLACE,	gdc_COMPLEMENT,		gdc_CLEAR,		gdc_SET,
		gdc_tdw,		gdc_tdw,			gdc_nop,		gdc_tdw,
		gdc_rmw,		gdc_rmw,			gdc_nop,		gdc_rmw};


static void GDCOPE_CALL gdcsub_pset(WORD x, WORD y) {

	dots++;
	if (y > 409) {
		goto nopset;
	}
	else if (y == 409) {
		if (x >= 384) {
			goto nopset;
		}
	}
	else {
		if (x >= 640) {
			goto nopset;
		}
	}
	gdcsubope[operate + grcg.gdcwithgrcg]((y * 80) + (x >> 3), x & 7);
	return;

nopset:;
	pattern = (pattern << 1) | (pattern >> 15);
}
#endif



// --------------------------------------------------------------------------

static void gdcslavewait(NEVENT_ITEM *item) {

	if (item->flag & NEVENT_SETEVENT) {
		gdc.s_drawing = 0;							// clear DRAWING
	}
}

static void calc_gdcslavewait(void) {								// ver0.28

	int		clk;

	clk = dots;
	if (pc.baseclock != PCBASECLOCK20) {
		clk *= 27648;
	}
	else {
		clk *= 22464;
	}
	clk *= pc.multiple;
	clk /= 15625;
	clk += 30 * pc.multiple;
	gdc.s_drawing = 8;							// GDC DRAWING!
	nevent_set(NEVENT_GDCSLAVE, clk, gdcslavewait, NEVENT_ABSOLUTE);
}

void gdcsub_line(DWORD csrw, BYTE *vect, WORD pat, BYTE ope) {

	WORD	x, y;
	WORD	i;
	WORD	step;
	WORD	dc;

	if (gdcsub_prepart(csrw, pat, ope, &x, &y)) {
		return;
	}
	dc = GETWORD(vect + GDCVCT_DC) & 0x3fff;
	if (!dc) {
		gdcsub_pset(x, y);
	}
	else {
		DWORD D1 = GETWORD(vect + GDCVCT_D1);
		switch(vect[GDCVCT_OPE] & 7) {
			case 0:
				for (i=0; i<=dc; i++) {
					step = (WORD)((((D1 * i) / dc) + 1) >> 1);
					gdcsub_pset(x+step, y++);
				}
				break;

			case 1:
				for (i=0; i<=dc; i++) {
					step = (WORD)((((D1 * i) / dc) + 1) >> 1);
					gdcsub_pset(x++, y+step);
				}
				break;

			case 2:
				for (i=0; i<=dc; i++) {
					step = (WORD)((((D1 * i) / dc) + 1) >> 1);
					gdcsub_pset(x++, y-step);
				}
				break;

			case 3:
				for (i=0; i<=dc; i++) {
					step = (WORD)((((D1 * i) / dc) + 1) >> 1);
					gdcsub_pset(x+step, y--);
				}
				break;

			case 4:
				for (i=0; i<=dc; i++) {
					step = (WORD)((((D1 * i) / dc) + 1) >> 1);
					gdcsub_pset(x-step, y--);
				}
				break;

			case 5:
				for (i=0; i<=dc; i++) {
					step = (WORD)((((D1 * i) / dc) + 1) >> 1);
					gdcsub_pset(x--, y-step);
				}
				break;

			case 6:
				for (i=0; i<=dc; i++) {
					step = (WORD)((((D1 * i) / dc) + 1) >> 1);
					gdcsub_pset(x--, y+step);
				}
				break;

			case 7:
				for (i=0; i<=dc; i++) {
					step = (WORD)((((D1 * i) / dc) + 1) >> 1);
					gdcsub_pset(x-step, y++);
				}
				break;
		}
	}
	calc_gdcslavewait();
}

void gdcsub_box(DWORD csrw, BYTE *vect, WORD pat, BYTE ope) {

	WORD	x, y;
	WORD	i;
	WORD	d, d2;

	if (gdcsub_prepart(csrw, pat, ope, &x, &y)) {
		return;
	}
	d = GETWORD(vect + GDCVCT_D) & 0x3fff;
	d2 = GETWORD(vect + GDCVCT_D2) & 0x3fff;
	// žϤʤ(ȴ)
	switch(vect[GDCVCT_OPE] & 7) {
		case 0:
			for (i=0; i<d; i++) {
				gdcsub_pset(x, y++);
			}
			for (i=0; i<d2; i++) {
				gdcsub_pset(x++, y);
			}
			for (i=0; i<d; i++) {
				gdcsub_pset(x, y--);
			}
			for (i=0; i<d2; i++) {
				gdcsub_pset(x--, y);
			}
			break;

		case 2:
			for (i=0; i<d; i++) {
				gdcsub_pset(x++, y);
			}
			for (i=0; i<d2; i++) {
				gdcsub_pset(x, y--);
			}
			for (i=0; i<d; i++) {
				gdcsub_pset(x--, y);
			}
			for (i=0; i<d2; i++) {
				gdcsub_pset(x, y++);
			}
			break;

		case 4:
			for (i=0; i<d; i++) {
				gdcsub_pset(x, y--);
			}
			for (i=0; i<d2; i++) {
				gdcsub_pset(x--, y);
			}
			for (i=0; i<d; i++) {
				gdcsub_pset(x, y++);
			}
			for (i=0; i<d2; i++) {
				gdcsub_pset(x++, y);
			}
			break;

		case 6:
			for (i=0; i<d; i++) {
				gdcsub_pset(x--, y);
			}
			for (i=0; i<d2; i++) {
				gdcsub_pset(x, y++);
			}
			for (i=0; i<d; i++) {
				gdcsub_pset(x++, y);
			}
			for (i=0; i<d2; i++) {
				gdcsub_pset(x, y--);
			}
			break;
	}
	calc_gdcslavewait();
}


void gdcsub_circle(DWORD csrw, BYTE *vect, WORD pat, BYTE ope) {

	WORD	x, y;
	WORD	i, t;
	WORD	r, m, c;

	if (gdcsub_prepart(csrw, pat, ope, &x, &y)) {
		return;
	}
	i = GETWORD(vect + GDCVCT_DM) & 0x3fff;
	t = GETWORD(vect + GDCVCT_DC) & 0x3fff;
	r = GETWORD(vect + GDCVCT_D) & 0x3fff;
	m = (WORD)(((DWORD)r * 10000 + 14141) / 14142);
	if (!m) {
		gdcsub_pset(x, y);
	}
	else {
		if (t > m) {
			t = m;
		}
		switch(vect[GDCVCT_OPE] & 7) {
			case 0:
				for (; i<=t; i++) {
					c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
					gdcsub_pset((WORD)(x + (((DWORD)gdc_rt[c] * r +
							(1 << (RT_MULBIT - 1))) >> RT_MULBIT)), y + i);
				}
				break;

			case 1:
				for (; i<=t; i++) {
					c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
					gdcsub_pset(x + i, (WORD)(y + (((DWORD)gdc_rt[c] * r +
							(1 << (RT_MULBIT - 1))) >> RT_MULBIT)));
				}
				break;

			case 2:
				for (; i<=t; i++) {
					c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
					gdcsub_pset(x + i, (WORD)(y - (((DWORD)gdc_rt[c] * r +
								(1 << (RT_MULBIT - 1))) >> RT_MULBIT)));
				}
				break;

			case 3:
				for (; i<=t; i++) {
					c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
					gdcsub_pset((WORD)(x + (((DWORD)gdc_rt[c] * r +
							(1 << (RT_MULBIT - 1))) >> RT_MULBIT)), y - i);
				}
				break;

			case 4:
				for (; i<=t; i++) {
					c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
					gdcsub_pset((WORD)(x - (((DWORD)gdc_rt[c] * r +
							(1 << (RT_MULBIT - 1))) >> RT_MULBIT)), y - i);
				}
				break;

			case 5:
				for (; i<=t; i++) {
					c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
					gdcsub_pset(x - i, (WORD)(y - (((DWORD)gdc_rt[c] * r +
							(1 << (RT_MULBIT - 1))) >> RT_MULBIT)));
				}
				break;

			case 6:
				for (; i<=t; i++) {
					c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
					gdcsub_pset(x - i, (WORD)(y + (((DWORD)gdc_rt[c] * r +
							(1 << (RT_MULBIT - 1))) >> RT_MULBIT)));
				}
				break;

			case 7:
				for (; i<=t; i++) {
					c = (WORD)(((DWORD)i << RT_TABLEBIT) / m);
					gdcsub_pset((WORD)(x - (((DWORD)gdc_rt[c] * r +
							(1 << (RT_MULBIT - 1))) >> RT_MULBIT)), y + i);
				}
				break;
		}
	}
	calc_gdcslavewait();
}
