#include	"compiler.h"

#include	"np2.h"
#include	"np2pc98.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"gdc.h"
#include	"gdc_cmd.h"
#include	"dispsync.h"
#include	"makegrph.h"


	DWORD	grph_table[4*256*2];

void makegrph_init(void) {

	int		i, j;
	BYTE	bit;
	DWORD	tmp = 0;								// vc++4.2

	for (i=0; i<256; i++) {
#if (defined(NP2_LITTLEENDIAN) || defined(NP2_TESTBIGENDIAN))
		for (bit=1; bit<0x10; bit<<=1)
#else
		for (bit=8; bit; bit>>=1)
#endif
		{
			tmp <<= 8;
			if (i & bit) {
				tmp++;
			}
		}
		for (j=0; j<4; j++, tmp<<=1) {
			grph_table[j*512+i*2+1] = tmp;
		}
#if (defined(NP2_LITTLEENDIAN) || defined(NP2_TESTBIGENDIAN))
		for (; bit; bit<<=1)
#else
		for (bit=0x80; bit & 0xf0; bit>>=1)
#endif
		{
			tmp <<= 8;
			if (i & bit) {
				tmp++;
			}
		}
		for (j=0; j<4; j++, tmp<<=1) {
			grph_table[j*512+i*2+0] = tmp;
		}
	}
}


static	DWORD	GRP_LR;
static	DWORD	LINE_WIDTH;


//	dsync.grphymax 									// ver0.26
// static	DWORD	GMAXLINE;

#ifdef NP2_MAKEGRPH_ASM

static	BYTE	DISPPAGE;
static	BYTE	ALL_DRAWFLAG;

LABEL void FASTCALL makegrph(int page, int alldraw) {

		__asm {
				pushad
				mov		edi, offset np2_vram					// ver0.26
				add		edi, dsync.grphvad
				and		ecx, 1
				je		short np2vram_adjpg
				add		edi, TYPE np2_vram[0]
np2vram_adjpg:
				inc		cl
				mov		DISPPAGE, cl
				mov		ALL_DRAWFLAG, dl
				mov		ch, cl
				xor		eax, eax
				mov		ax, cx
				shl		eax, 16
				mov		ax, cx

				cmp		dl, 0
				je		calc_maxline
				mov		ecx, 2000h
				mov		ebx, offset vramupdate
dirtyfill_lp:	or		[ebx], eax
				add		ebx, 4
				loop	dirtyfill_lp

calc_maxline:	push	eax
#if 0															// ver0.26
				movzx	eax, word ptr (gdc.s.para[GDC_SYNC + 6])
				and		eax, 003ffh
				je		calc1_maxline
				cmp		eax, GRPHYMAX
				jbe		calc2_maxline
calc1_maxline:	mov		eax, GRPHYMAX
calc2_maxline:	mov		GMAXLINE, eax
#endif
				movzx	eax, gdc.s.para[GDC_CSRFORM]
				and		eax, 0x1f
				mov		GRP_LR, eax
				movzx	eax, gdc.s.para[GDC_PITCH]
				cmp		gdc.clock, 0
				js		calc1_width
				add		eax, eax
calc1_width:	and		eax, 0000feh				// uPD72020ǳǧ
				mov		LINE_WIDTH, eax

				mov		ebx, dsync.grph_vbp						// ver0.26
draw_lp:		movzx	esi, word ptr (gdc.s.para[GDC_SCROLL+0+0])
				movzx	ecx, word ptr (gdc.s.para[GDC_SCROLL+0+2])
				call	grphputlines
				movzx	esi, word ptr (gdc.s.para[GDC_SCROLL+4+0])
				movzx	ecx, word ptr (gdc.s.para[GDC_SCROLL+4+2])
				call	grphputlines
				cmp		np2cfg.uPD72020, 0
				jne		draw_lp
				movzx	esi, word ptr (gdc.s.para[GDC_SCROLL+8+0])
				movzx	ecx, word ptr (gdc.s.para[GDC_SCROLL+8+2])
				call	grphputlines
				movzx	esi, word ptr (gdc.s.para[GDC_SCROLL+12+0])
				movzx	ecx, word ptr (gdc.s.para[GDC_SCROLL+12+2])
				push	offset draw_lp

grphputlines:		and		esi, 3fffh
					add		esi, esi
					shr		ecx, 4
					and		ecx, 03ffh
					jne		grphlineput_st
					mov		ecx, 0400h
grphlineput_st:		push	ecx

grphlineput_lp:		mov		ecx, GRP_LR
grphline1_lp:		test	bl, 1
					je		grph_putline
					test	gdc.mode1, 10h
					je		grph_putline
													// 00/07/12
													// λ˥åץ饤
					add		edi, 640				// ȿǤΤǡ
					cmp		ALL_DRAWFLAG, 0
					je		putline_end
					mov		al, DISPPAGE
					or		renewal_line[ebx], al
					jmp		putline_end

grph_putline:		push	esi
					push	ecx
					mov		ebp, 80
					cmp		DISPPAGE, 1
					jne		bank1_linelp
bank0_linelp:		test	vramupdate[esi], 1
					je		bank0_nodirty
					or		renewal_line[ebx], 1
					movzx	edx, byte ptr mem[esi + VRAM0_B]
					mov		eax, grph_table[edx*8+0*0x800+0]
					mov		ecx, grph_table[edx*8+0*0x800+4]
					movzx	edx, byte ptr mem[esi + VRAM0_R]
					or		eax, grph_table[edx*8+1*0x800+0]
					or		ecx, grph_table[edx*8+1*0x800+4]
					movzx	edx, byte ptr mem[esi + VRAM0_G]
					or		eax, grph_table[edx*8+2*0x800+0]
					or		ecx, grph_table[edx*8+2*0x800+4]
					movzx	edx, byte ptr mem[esi + VRAM0_E]
					or		eax, grph_table[edx*8+3*0x800+0]
					or		ecx, grph_table[edx*8+3*0x800+4]
					mov		[edi], eax
					mov		[edi+4], ecx
bank0_nodirty:		inc		esi
					and		esi, 07fffh
					add		edi, 8
					dec		ebp
					jne		bank0_linelp
					jmp		bankputend
bank1_linelp:		test	vramupdate[esi], 2
					je		bank1_nodirty
					or		renewal_line[ebx], 2
					movzx	edx, byte ptr mem[esi + VRAM1_B]
					mov		eax, grph_table[edx*8+0*0x800+0]
					mov		ecx, grph_table[edx*8+0*0x800+4]
					movzx	edx, byte ptr mem[esi + VRAM1_R]
					or		eax, grph_table[edx*8+1*0x800+0]
					or		ecx, grph_table[edx*8+1*0x800+4]
					movzx	edx, byte ptr mem[esi + VRAM1_G]
					or		eax, grph_table[edx*8+2*0x800+0]
					or		ecx, grph_table[edx*8+2*0x800+4]
					movzx	edx, byte ptr mem[esi + VRAM1_E]
					or		eax, grph_table[edx*8+3*0x800+0]
					or		ecx, grph_table[edx*8+3*0x800+4]
					mov		[edi], eax
					mov		[edi+4], ecx
bank1_nodirty:		inc		esi
					and		esi, 07fffh
					add		edi, 8
					dec		ebp
					jne		bank1_linelp
bankputend:			pop		ecx
					pop		esi

putline_end:		inc		ebx
					cmp		ebx, dsync.grphymax					// ver0.26
					jnc		grph_break
					dec		dword ptr [esp]
					je		grphline1_ed
					dec		ecx
					jns		grphline1_lp
					add		esi, LINE_WIDTH
					and		esi, 7fffh
					jmp		grphlineput_lp
grphline1_ed:		pop		ecx
					ret

grph_break:		add		esp, 8
				pop		edx
#if 0															// ver0.28
				cmp		ALL_DRAWFLAG, 0
				je		deldirty

				cmp		ebx, dsync.scrnymax						// ver0.26
				jae		deldirty
				xor		eax, eax
bottomfill0_lp:	or		renewal_line[ebx], dl
				mov		ecx, 640/4
bottomfill1_lp:	mov		[edi], eax
				add		edi, 4
				loop	bottomfill1_lp
				inc		ebx
				cmp		ebx, dsync.scrnymax						// ver0.26
				jb		bottomfill0_lp
deldirty:
#endif
				mov		ecx, 2000h
				mov		ebx, offset vramupdate
				not		edx
deldirty_lp:	and		[ebx], edx
				add		ebx, 4
				loop	deldirty_lp
				popad
				ret
		}
}
#else

static	DWORD	liney;
static	DWORD	*vm;

static BOOL grphput_indirty0(int gpos) {

	DWORD	vad;
	DWORD	remain;
	int		times;
	DWORD	vc;
	DWORD	*p;
	BYTE	dat;
	DWORD	l;
	DWORD	r;
	DWORD	mul;

	vad = (GETWORD(gdc.s.para + GDC_SCROLL + gpos + 0) & 0x3fff) << 1;
	remain = (GETWORD(gdc.s.para + GDC_SCROLL + gpos + 2)) >> 4;
	remain &= 0x3ff;
	do {
		mul = GRP_LR;
		do {
			if ((!(liney & 1)) || (!(gdc.mode1 & 0x10))) {
				vc = vad;
				p = vm;
				times = 80;
				do {
					if (vramupdate[vc] & 1) {
						renewal_line[liney] |= 1;
						dat = MEM_GETB(vc + VRAM0_B);
						l = grph_table[dat*2 + 0*0x200 + 0];
						r = grph_table[dat*2 + 0*0x200 + 1];
						dat = MEM_GETB(vc + VRAM0_R);
						l |= grph_table[dat*2 + 1*0x200 + 0];
						r |= grph_table[dat*2 + 1*0x200 + 1];
						dat = MEM_GETB(vc + VRAM0_G);
						l |= grph_table[dat*2 + 2*0x200 + 0];
						r |= grph_table[dat*2 + 2*0x200 + 1];
						dat = MEM_GETB(vc + VRAM0_E);
						l |= grph_table[dat*2 + 3*0x200 + 0];
						r |= grph_table[dat*2 + 3*0x200 + 1];
						p[0] = l;
						p[1] = r;
					}
					p += 2;
					vc = (vc + 1) & 0x7fff;
				} while(--times);
			}
			liney++;
			if (liney >= dsync.grphymax) {
				return(TRUE);
			}
			vm += 80*2;
		} while(--mul);
		vad = (vad + LINE_WIDTH) & 0x7fff;
	} while(--remain);
	return(FALSE);
}

static BOOL grphput_indirty1(int gpos) {

	DWORD	vad;
	DWORD	remain;
	int		times;
	DWORD	vc;
	DWORD	*p;
	BYTE	dat;
	DWORD	l;
	DWORD	r;
	DWORD	mul;

	vad = (GETWORD(gdc.s.para + GDC_SCROLL + gpos + 0) & 0x3fff) << 1;
	remain = (GETWORD(gdc.s.para + GDC_SCROLL + gpos + 2)) >> 4;
	remain &= 0x3ff;
	do {
		mul = GRP_LR;
		do {
			if ((!(liney & 1)) || (!(gdc.mode1 & 0x10))) {
				vc = vad;
				p = vm;
				times = 80;
				do {
					if (vramupdate[vc] & 2) {
						renewal_line[liney] |= 2;
						dat = MEM_GETB(vc + VRAM1_B);
						l = grph_table[dat*2 + 0*0x200 + 0];
						r = grph_table[dat*2 + 0*0x200 + 1];
						dat = MEM_GETB(vc + VRAM1_R);
						l |= grph_table[dat*2 + 1*0x200 + 0];
						r |= grph_table[dat*2 + 1*0x200 + 1];
						dat = MEM_GETB(vc + VRAM1_G);
						l |= grph_table[dat*2 + 2*0x200 + 0];
						r |= grph_table[dat*2 + 2*0x200 + 1];
						dat = MEM_GETB(vc + VRAM1_E);
						l |= grph_table[dat*2 + 3*0x200 + 0];
						r |= grph_table[dat*2 + 3*0x200 + 1];
						p[0] = l;
						p[1] = r;
					}
					p += 2;
					vc = (vc + 1) & 0x7fff;
				} while(--times);
			}
			liney++;
			if (liney >= dsync.grphymax) {
				return(TRUE);
			}
			vm += 80*2;
		} while(--mul);
		vad = (vad + LINE_WIDTH) & 0x7fff;
	} while(--remain);
	return(FALSE);
}


static BOOL grphput_all0(int gpos) {

	DWORD	vad;
	DWORD	remain;
	int		times;
	DWORD	vc;
	DWORD	*p;
	BYTE	dat;
	DWORD	l;
	DWORD	r;
	DWORD	mul;

	vad = (GETWORD(gdc.s.para + GDC_SCROLL + gpos + 0) & 0x3fff) << 1;
	remain = (GETWORD(gdc.s.para + GDC_SCROLL + gpos + 2)) >> 4;
	remain &= 0x3ff;
	do {
		mul = GRP_LR;
		do {
			if ((!(liney & 1)) || (!(gdc.mode1 & 0x10))) {
				vc = vad;
				p = vm;
				times = 80;
				do {
					dat = MEM_GETB(vc + VRAM0_B);
					l = grph_table[dat*2 + 0*0x200 + 0];
					r = grph_table[dat*2 + 0*0x200 + 1];
					dat = MEM_GETB(vc + VRAM0_R);
					l |= grph_table[dat*2 + 1*0x200 + 0];
					r |= grph_table[dat*2 + 1*0x200 + 1];
					dat = MEM_GETB(vc + VRAM0_G);
					l |= grph_table[dat*2 + 2*0x200 + 0];
					r |= grph_table[dat*2 + 2*0x200 + 1];
					dat = MEM_GETB(vc + VRAM0_E);
					l |= grph_table[dat*2 + 3*0x200 + 0];
					r |= grph_table[dat*2 + 3*0x200 + 1];
					p[0] = l;
					p[1] = r;
					p += 2;
					vc = (vc + 1) & 0x7fff;
				} while(--times);
			}
			renewal_line[liney] |= 1;
			liney++;
			if (liney >= dsync.grphymax) {
				return(TRUE);
			}
			vm += 80*2;
		} while(--mul);
		vad = (vad + LINE_WIDTH) & 0x7fff;
	} while(--remain);
	return(FALSE);
}

static BOOL grphput_all1(int gpos) {

	DWORD	vad;
	DWORD	remain;
	int		times;
	DWORD	vc;
	DWORD	*p;
	DWORD	dat;
	DWORD	l;
	DWORD	r;
	DWORD	mul;

	vad = (GETWORD(gdc.s.para + GDC_SCROLL + gpos + 0) & 0x3fff) << 1;
	remain = (GETWORD(gdc.s.para + GDC_SCROLL + gpos + 2)) >> 4;
	remain &= 0x3ff;
	do {
		mul = GRP_LR;
		do {
			if ((!(liney & 1)) || (!(gdc.mode1 & 0x10))) {
				vc = vad;
				p = vm;
				times = 80;
				do {
					dat = MEM_GETB(vc + VRAM1_B);
					l = grph_table[dat*2 + 0*0x200 + 0];
					r = grph_table[dat*2 + 0*0x200 + 1];
					dat = MEM_GETB(vc + VRAM1_R);
					l |= grph_table[dat*2 + 1*0x200 + 0];
					r |= grph_table[dat*2 + 1*0x200 + 1];
					dat = MEM_GETB(vc + VRAM1_G);
					l |= grph_table[dat*2 + 2*0x200 + 0];
					r |= grph_table[dat*2 + 2*0x200 + 1];
					dat = MEM_GETB(vc + VRAM1_E);
					l |= grph_table[dat*2 + 3*0x200 + 0];
					r |= grph_table[dat*2 + 3*0x200 + 1];
					p[0] = l;
					p[1] = r;
					p += 2;
					vc = (vc + 1) & 0x7fff;
				} while(--times);
			}
			renewal_line[liney] |= 2;
			liney++;
			if (liney >= dsync.grphymax) {
				return(TRUE);
			}
			vm += 80*2;
		} while(--mul);
		vad = (vad + LINE_WIDTH) & 0x7fff;
	} while(--remain);
	return(FALSE);
}

void MAKESCRN_CALL makegrph(int page, int alldraw) {

	DWORD	pitch;
	int		va;

	pitch = gdc.s.para[GDC_PITCH];
	if (!(gdc.clock & 0x80)) {
		pitch <<= 1;
	}
	LINE_WIDTH = pitch & 0x00fe;
	GRP_LR = (gdc.s.para[GDC_CSRFORM] & 0x1f) + 1;

	liney = dsync.grph_vbp;
	if (!page) {										// ǳڤ
		vm = (DWORD *)(np2_vram[0] + dsync.grphvad);
		if (!alldraw) {							// page=0, ʬ
			liney = dsync.grph_vbp;
			while(1) {
				if (grphput_indirty0(0)) {
					break;
				}
				if (grphput_indirty0(4)) {
					break;
				}
				if (np2cfg.uPD72020) {
					continue;
				}
				if (grphput_indirty0(8)) {
					break;
				}
				if (grphput_indirty0(12)) {
					break;
				}
			}
		}
		else {									// page=0, redraw
			while(1) {
				if (grphput_all0(0)) {
					break;
				}
				if (grphput_all0(4)) {
					break;
				}
				if (np2cfg.uPD72020) {
					continue;
				}
				if (grphput_all0(8)) {
					break;
				}
				if (grphput_all0(12)) {
					break;
				}
			}
		}
		for (va=0; va<0x8000; va++) {
			vramupdate[va] &= ~1;
		}
	}
	else {
		vm = (DWORD *)(np2_vram[1] + dsync.grphvad);
		if (!alldraw) {							// page=1, ʬ
			liney = dsync.grph_vbp;
			while(1) {
				if (grphput_indirty1(0)) {
					break;
				}
				if (grphput_indirty1(4)) {
					break;
				}
				if (np2cfg.uPD72020) {
					continue;
				}
				if (grphput_indirty1(8)) {
					break;
				}
				if (grphput_indirty1(12)) {
					break;
				}
			}
		}
		else {									// page=1, redraw
			while(1) {
				if (grphput_all1(0)) {
					break;
				}
				if (grphput_all1(4)) {
					break;
				}
				if (np2cfg.uPD72020) {
					continue;
				}
				if (grphput_all1(8)) {
					break;
				}
				if (grphput_all1(12)) {
					break;
				}
			}
		}
		for (va=0; va<0x8000; va++) {
			vramupdate[va] &= ~2;
		}
	}
}
#endif
