#include	"compiler.h"

#include	"nevent.h"
#include	"pc_core.h"										// ver0.26

#ifdef __cplusplus
extern "C" {
#endif
NEVENT_TABLE	nevent;
#ifdef __cplusplus
}
#endif


void nevent_init(void) {

	// ٤Ƥꥻå
	ZeroMemory(&nevent, sizeof(NEVENT_TABLE));
}


void nevent_get1stevent(void) {

	// ûΥ٥ȤΥå򥻥å
	if (nevent.readyevents) {
		nevent.baseclock = nevent.item[nevent.level[0]].clock;
	}
	else {
		// ٥ȤʤΥå򥻥å
		nevent.baseclock = NEVENT_MAXCLOCK;
	}

	// 󥿤إå
	nevent.remainclock = nevent.baseclock;
}


static void nevent_execute(void) {

	int			i;
	int			eventnum = 0;
	DWORD		curid;
	NEVENT_ITEM	*item;

	for (i=0; i<nevent.waitevents; i++) {
		curid = nevent.waitevent[i];
		item = &nevent.item[curid];

		// Хåμ¹
		if (item->proc != NULL) {
			item->proc(item);

			// ˻ۤΥ٥ȤΥå
			if (item->flag & NEVENT_WAIT) {
				nevent.waitevent[eventnum++] = curid;
			}
		}
		else {
			item->flag &= ~(NEVENT_WAIT);
		}
		item->flag &= ~(NEVENT_SETEVENT);
	}
	nevent.waitevents = eventnum;
}


void nevent_progress(void) {

	int			i;
	int			eventnum = 0;
	DWORD		curid;
	NEVENT_ITEM	*item;
	long		nextbase = NEVENT_MAXCLOCK;

	nevent.clock += nevent.baseclock;
	for (i=0; i<nevent.readyevents; i++) {
		curid = nevent.level[i];
		item = &nevent.item[curid];
		item->clock -= nevent.baseclock;
		if (item->clock > 0) {
			// ٥Ԥ
			nevent.level[eventnum++] = curid;
			if (nextbase >= item->clock) {
				nextbase = item->clock;
			}
		}
		else {
			// ٥ȯ
			if (!(item->flag & (NEVENT_SETEVENT | NEVENT_WAIT))) {
				nevent.waitevent[nevent.waitevents++] = curid;
			}
			item->flag |= NEVENT_SETEVENT;
			item->flag &= ~(NEVENT_ENABLE);
		}
	}
	nevent.readyevents = eventnum;
	nevent.baseclock = nextbase;
	nevent.remainclock += nextbase;
	nevent_execute();
}


void nevent_reset(int id) {

	int			i;

	// ߿ʹԤƤ륤٥Ȥ򸡺
	for (i=0; i<nevent.readyevents; i++) {
		if (nevent.level[i] == id) {
			break;
		}
	}

	// ٥Ȥ¸ߤ
	if (i < nevent.readyevents) {

		// ¸ߤƤ
		nevent.readyevents--;
		for (; i<nevent.readyevents; i++) {
			nevent.level[i] = nevent.level[i+1];
		}
	}
}

void nevent_waitreset(int id) {

	int			i;

	// ߿ʹԤƤ륤٥Ȥ򸡺
	for (i=0; i<nevent.waitevents; i++) {
		if (nevent.waitevent[i] == id) {
			break;
		}
	}

	// ٥Ȥ¸ߤ
	if (i < nevent.waitevents) {

		// ¸ߤƤ
		nevent.waitevents--;
		for (; i<nevent.waitevents; i++) {
			nevent.waitevent[i] = nevent.waitevent[i+1];
		}
	}
}


void nevent_set(int id, long eventclock, void *proc, BOOL absolute) {

	int			i;
	int			eventid;
	long		clock;
	NEVENT_ITEM	*item;

	clock = nevent.baseclock - nevent.remainclock;
	item = &nevent.item[id];
	item->proc = (void (*)(void *))proc;
	item->flag = 0;
	if (absolute) {
		item->clock = eventclock + clock;
	}
	else {
		item->clock += eventclock;
	}
#if 0
	if (item->clock < clock) {
		item->clock = clock;
	}
#endif
	// ٥Ȥκ
	nevent_reset(id);

	// ٥Ȥ֤θ
	for (eventid=0; eventid<nevent.readyevents; eventid++) {
		if (item->clock < nevent.item[nevent.level[eventid]].clock) {
			break;
		}
	}

	// ٥Ȥ
	for (i=nevent.readyevents; --i>=eventid;) {
		nevent.level[i+1] = nevent.level[i];
	}
	nevent.level[eventid] = id;
	nevent.readyevents++;

	// ⤷û٥Ȥä...
	if (eventid == 0) {
		clock = nevent.baseclock - item->clock;
		nevent.baseclock -= clock;
		nevent.remainclock -= clock;
	}
}


															// ver0.26
void nevent_setbyms(int id, long ms, void *proc, BOOL absolute) {

	nevent_set(id, (pc.realclock / 1000) * ms, proc, absolute);
}



BOOL nevent_iswork(int id) {

	int			i;

	// ߿ʹԤƤ륤٥Ȥ򸡺
	for (i=0; i<nevent.readyevents; i++) {
		if (nevent.level[i] == id) {
			return(TRUE);
		}
	}
	return(FALSE);
}


long nevent_getremain(int id) {

	int			i;

	// ߿ʹԤƤ륤٥Ȥ򸡺
	for (i=0; i<nevent.readyevents; i++) {
		if (nevent.level[i] == id) {
			return(nevent.item[id].clock -
								(nevent.baseclock - nevent.remainclock));
		}
	}
	return(-1);
}


void nevent_forceexit(void) {

	if (nevent.remainclock > 0) {
		nevent.baseclock -= nevent.remainclock;
		nevent.remainclock = 0;
	}
}
