#include	"compiler.h"

#include	"np2.h"
#include	"fmtimer.h"
#include	"psg.h"
#include	"np2sound.h"
#include	"iobridge.h"
#include	"serial.h"


		PSG_T	psgreg[2];

static	BYTE	psgenv_pat[16] = {
					PSGENV_ONESHOT,
					PSGENV_ONESHOT,
					PSGENV_ONESHOT,
					PSGENV_ONESHOT,
					PSGENV_ONESHOT | PSGENV_INC,
					PSGENV_ONESHOT | PSGENV_INC,
					PSGENV_ONESHOT | PSGENV_INC,
					PSGENV_ONESHOT | PSGENV_INC,
					PSGENV_ONECYCLE,
					PSGENV_ONESHOT,
					0,
					PSGENV_ONESHOT | PSGENV_LASTON,
					PSGENV_ONECYCLE | PSGENV_INC,
					PSGENV_ONESHOT | PSGENV_INC | PSGENV_LASTON,
					PSGENV_INC,
					PSGENV_ONESHOT | PSGENV_INC};

//-----------------------------------------------------------------------------

static BYTE psginittbl[0x10] =
				{0, 0, 0, 0, 0, 0, 0, 0xbf, 0, 0, 0, 0, 0, 0, 0xff, 0xff};

void psg_reset(int psgnum) {

	BYTE	i;

	for (i=0; i<0x10; i++) {
		psg_setreg(psgnum, i, psginittbl[i]);
	}
}

void psg_volume(void) {											// ver0.28

	int		i;
	DWORD	mul;

	mul = np2cfg.vol_ssg;
	for (i=1; i<16; i++) {
		psg_voltbl[i] = (psg_basevoltbl[i] * mul) >> (6 + PSGADDEDBIT);
	}
}

void psg_setreg(int psgnum, int reg, BYTE value) {

	PSG_T	*psg = &psgreg[psgnum];
	DWORD	tmp;

	psg->reg[reg] = value;
	switch(reg) {
		case PSGREG_TUNE1L:
		case PSGREG_TUNE1H:
			tmp = GETWORD(psg->reg + PSGREG_TUNE1L) & 0xfff;
			if (tmp > 9) {
				psg->psgtone[0].psgtone_freq =					// ver0.28
								(psg_base / tmp) << PSGFREQPADBIT;
			}
			else {
				psg->psgtone[0].psgtone_freq = 0;
			}
			break;

		case PSGREG_TUNE2L:
		case PSGREG_TUNE2H:
			tmp = GETWORD(psg->reg + PSGREG_TUNE2L) & 0xfff;
			if (tmp > 9) {
				psg->psgtone[1].psgtone_freq =					// ver0.28
								(psg_base / tmp) << PSGFREQPADBIT;
			}
			else {
				psg->psgtone[1].psgtone_freq = 0;
			}
			break;

		case PSGREG_TUNE3L:
		case PSGREG_TUNE3H:
			tmp = GETWORD(psg->reg + PSGREG_TUNE3L) & 0xfff;
			if (tmp > 9) {
				psg->psgtone[2].psgtone_freq =					// ver0.28
								(psg_base / tmp) << PSGFREQPADBIT;
			}
			else {
				psg->psgtone[2].psgtone_freq = 0;
			}
			break;
		case PSGREG_NOISE:
			{
				int value = psg->reg[PSGREG_NOISE] & 0x1f;
				if (!value) {
					value = 1;
				}
				psg->psgnoise.freq = (psg_base / value) << PSGFREQPADBIT;
			}
			break;

		case PSGREG_MIXER:
			psg->psg_mixer = (~psg->reg[PSGREG_MIXER]);
			break;

		case PSGREG_VOLUME1:
			if (psg->reg[PSGREG_VOLUME1] & 0x10) {
				psg->psgtone[0].psgtone_volp = &(psg->psgenv_vol);
			}
			else {
				// 쥸˲ùƤ뤸			// ver0.28
//				psg->reg.vol1 &= 0xf;
				psg->psgtone[0].psgtone_volp = psg->reg + PSGREG_VOLUME1;
			}
			psg->psgtone[0].psgtone_puchi = psg_puchidec;
			break;

		case PSGREG_VOLUME2:
			if (psg->reg[PSGREG_VOLUME2] & 0x10) {
				psg->psgtone[1].psgtone_volp = &(psg->psgenv_vol);
			}
			else {
//				psg->reg.vol2 &= 0xf;							// ver0.28
				psg->psgtone[1].psgtone_volp = psg->reg + PSGREG_VOLUME2;
			}
			psg->psgtone[1].psgtone_puchi = psg_puchidec;
			break;

		case PSGREG_VOLUME3:
			if (psg->reg[PSGREG_VOLUME3] & 0x10) {
				psg->psgtone[2].psgtone_volp = &(psg->psgenv_vol);
			}
			else {
//				psg->reg.vol3 &= 0xf;							// ver0.28
				psg->psgtone[2].psgtone_volp = psg->reg + PSGREG_VOLUME3;
			}
			psg->psgtone[2].psgtone_puchi = psg_puchidec;
			break;

		case PSGREG_ENVTIMEL:
		case PSGREG_ENVTIMEH:
			if ((psg->psgenv_max = (WORD)(np2sound.rate *
					GETWORD(psg->reg + PSGREG_ENVTIMEL) / 125000L)) == 0) {
				psg->psgenv_max = 1;
			}
			break;
		case PSGREG_ENVTYPE:
			psg->psgenv_mod = psgenv_pat[psg->reg[PSGREG_ENVTYPE] & 0x0f];
			psg->psgenv_volcnt = 16;
			psg->psgenv_cnt = 1;
			break;
	}
}


BYTE psg_getjoyport(int psgnum) {

static	BYTE	rapids = 0;
		BYTE	ret;
		PSG_T	*psg = &psgreg[psgnum];

	rapids ^= 0xf0;											// ver0.28
	ret = 0xff;
	if (!(psg->reg[PSGREG_IO2] & 0x40)) {
		ret &= np2os_getjoypad() | (rapids & 0x30);
		if (np2cfg.KEY_MODE == 1) {
			ret &= joykey();
		}
	}
	else {
		if (np2cfg.KEY_MODE == 2) {
			ret &= joykey();
		}
	}
	if (np2cfg.BTN_RAPID) {
		ret |= rapids;
	}

	// rapidrapid								// ver0.28
	ret &= ((ret >> 2) | (~0x30));

	if (np2cfg.BTN_MODE) {
		BYTE bit1 = (ret & 0x20) >> 1;					// ver0.28
		BYTE bit2 = (ret & 0x10) << 1;
		ret = (ret & (~0x30)) | bit1 | bit2;
	}

	// intr ȿǤƽ								// ver0.28
	ret &= 0x3f;
	ret |= fmtimer.intr;
	return(ret);
}

